(function(app){
    var flashcard_audio_play = false;
	app.playAudio = function(e) {
        if(e.type === 'keypress' && e.keyCode !== 13 && e.keyCode !== 32)
            return false;

            var audioPath;
            var avatar_click = false;
            if($(this).hasClass("avatar_popup")) {
                audioPath = $(this).find('.qimage').attr('data-src');
                avatar_click = true;
                $('.qtitle_image').find('img').attr('src', 'images/'+config.data.avatar_active);
            }
            else{
                audioPath = $(this).attr('data-src');
                avatar_click = false;
            }
            if(!audioPath ) {
                audioPath = $(e.currentTarget).attr('data-src');
            }
            var index;
        if(audioPath != 'audio/'){
            index = config.data.soundKeyArr.lastIndexOf(audioPath);
            common.stopAudio(index);
            if (config.data.soundArr[index].playing()) {
                config.data.soundArr[index].pause();
            }
            else {
                config.data.soundArr[index].play();
            }


            config.data.soundArr[index].on('end', handleAvatar);
            //return false;
           /* if(!$(this).hasClass('active')){
                common.stopAudio();
                $('.audio').removeClass('active paused');
                $(this).addClass('active');
                flashcard_audio_play = false;
                if($(this).hasClass('flashcard_audio'))
                    flashcard_audio_play = true;
                if(avatar_click){
                    config.data.soundArr[index].on('end', handleAvatar);
                    //document.getElementById('playAudio').addEventListener('playing',handleAvatar,false);   
                }
                else{
                    //document.getElementById('playAudio').removeEventListener('playing', handleAvatar);
                }
                $('.audio').attr('aria-hidden','true');
            }
            else {
                if(!$(this).hasClass('paused')){
                    config.data.soundArr[index].pause();
                    $(this).addClass('paused');
                }
                else{
                    $(this).removeClass('paused');
                    config.data.soundArr[index].play();
                    $('.audio').attr('aria-hidden','true');
                }
            }*/  
        }     
        //$(this).unbind().bind('click keypress', continueAudio);
        e.preventDefault();      
        e.stopPropagation();
        e.stopImmediatePropagation();
    };
    function handleAvatar(e) {
        $('.avatar_popup').find('img').attr('src', 'images/'+config.data.avatar_in_active);
        
        /*var ele = $(e.target);
        //console.log($(this));
        setTimeout(function(){
            $('.qtitle_image').find('img').attr('src', 'images/'+config.data.avatar_active);
        },200);*/
    }
    app.stopAudio = function(index) {
        flashcard_audio_play = false;
        for(var i = 0; i < config.data.soundArr.length; i++){
            if(parseInt(i) != index) 
                config.data.soundArr[i].stop();
        }
        $('.audio').removeAttr('aria-hidden');
    }
    app.flashcard_audio_status = function(){
        console.log('flashcard_audio_play::', flashcard_audio_play);
        return flashcard_audio_play;
    }

    app.avtarPopup = function(e){
        if(e.type === 'keypress' && (e.keyCode !== 13 && e.keyCode !== 32))
            return false;
        $('.avatar_tooltip').remove();
        //$(this).find('img').attr('src', 'images/'+config.data.avatar_active);
        var $tooltip;
        //console.log('avtar',config.data.avatar_alt_text)
        if(config.data.avatar_alt_text != '') {
        $tooltip = $('<div class="tooltip avatar_tooltip tabindex" aria-label="' + config.data.avatar_alt_text + '" data-tooltip="0">' + config.data.avatar_alt_text + '\
            <div class="arrow"></div>\
            <a href="javascript:void(0)" class="qhintClose" aria-label="Close popup"><img src="../../images/close_callout.svg" /></a>\
        </div>');
        
        $(this).parents('.qtitle').append($tooltip);   
        holdThis = $(this);
        var linkPosition = $(this).position();
        var linkSize = $(this)[0].offsetParent;
        $tooltip.find('.qhintClose').attr('tabindex',$(this).attr('tabindex'));
        $tooltip.attr('tabindex',$(this).attr('tabindex'));
        }

        $("a.qhintClose").unbind().bind("click keypress", function(e) {
            if(e.type === 'keypress' && (e.keyCode !== 13 && e.keyCode !== 32))
                return false;

            $(this).parent().remove();
           /* var playAudio = $("#playAudio")[0];
            playAudio.pause();*/
            common.stopAudio();
        $('.avatar_popup').find('img').attr('src', 'images/'+config.data.avatar_in_active);
        $('.avatar_popup').removeClass('active');
        if(!isMobile())
            holdThis.focus();
        e.preventDefault();
        e.stopImmediatePropagation();
        });
        if(!isMobile())
            $('.avatar_tooltip').focus();

        e.stopPropagation();
    }
    
    /*$audio.on("ended", function() {
        $('.avatar_popup').attr('src', 'images/'+config.data.avatar_in_active);
        $('.audio').removeClass('active activeAudio').css('cursor','pointer');
        $('.audio').unbind().bind('click keypress touchstart', common.playAudio);
        $(".avatar_popup").unbind().bind('keypress click', common.avtarPopup);
        $(".avatar_popup").bind('keypress click', common.playAudio);

        $('.audio').removeAttr('aria-hidden');
        $('.audio, .avatar_popup').removeClass('active paused');
		$('.avatar_popup').find('img').attr('src', 'images/'+config.data.avatar_in_active);
    });
*/
    //remove focus for click    
    document.addEventListener('keydown', function(e) {
      if (e.keyCode === 9) {
        $('body').addClass('show-focus-outlines');
      }
    });
    document.addEventListener('click', function(e) {
      $('body').removeClass('show-focus-outlines');
    });
	
})(common = common || {});

function addTabIndex(){
    var tab_index = 0;
    $(".tabindex:visible").each(function(index){
        if(!$(this).hasClass('disabled')){
            $(this).attr("tabindex",tab_index);
            // tab_index++;    
        }else{
            $(this).attr("tabindex","-1");
        }
    });
}
function removeTabIndex(){
    $(".tabindex:visible").each(function(index){
        $(this).attr("tabindex", -1);
    }); 
}
function shuffle(array) {
    var currentIndex = array.length,
        temporaryValue, randomIndex;
    while (0 !== currentIndex) {
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }
    return array;
}
function getAudios(jsonData){
  var result;
  var pattern = /.mp3$/g;
  if(jsonData.length){
    for(var i = 0; i < jsonData.length; i++){
      var jsonValue = jsonData[i];
      if(typeof jsonValue == 'string' ){
        pattern = /.mp3$/g;
        result = pattern.test(jsonValue);
        if(result)
        {
          console.log(audioPreloadArray.length)
          audioPreloadArray.push("audio/"+jsonValue);
        }
      }
      else{
        getAudios(jsonValue);
      }
    }
  }
  else{
    for (var key in jsonData) {
      if (jsonData.hasOwnProperty(key)) {
        var jsonValue = jsonData[key];
        if(typeof jsonValue == 'string' ){
          pattern = /.mp3$/g;
          result = pattern.test(jsonValue);
          if(result)
          {
          console.log(audioPreloadArray.length)
            audioPreloadArray.push("audio/"+jsonValue);
          }
        }
        else{
          getAudios(jsonValue);
        }
      }
    }
  }
}
$(document).ready(function(){
    isMobile = function()  {  
        //return 'ontouchstart' in window || 'onmsgesturechange' in window; 
         if( navigator.userAgent.match(/Android/i)
     || navigator.userAgent.match(/webOS/i)
     || navigator.userAgent.match(/iPhone/i)
     || navigator.userAgent.match(/iPad/i)
     || navigator.userAgent.match(/iPod/i)
     || navigator.userAgent.match(/BlackBerry/i)
     || navigator.userAgent.match(/Windows Phone/i)
     ){
        return true;
      }
     else {
        return false;
      }
    };
});
var isMobile;
var common;