/* DND1 widget File */
(function(app){
    var aSlidesArray = new Array();
    var nSlideCounter = 0;
    var nCount = 0;
    var title;
    var questionWrapper;
    var answerContainer;
    var attempts;
    var submitButton;
    var showcorrectButton;
    var showMyAnsButton;
    var resetButton;
    var maincontainer;
    var currentTabIndex;
    var DragSet = "";
    var tempParent;
    var dragspotWrapper;
    var totalAttempts = 0;
    var activityTotalAttempts = 3;
    var all_correct;
    var incorrectArray = [];
    var incorrectOptions = [];
    var frameDragspot = 2;
    var innerWidth = $(window).innerWidth();
    var innerHeight = $(window).innerHeight();
    var userAnswers = [];
    //
    var OptionArray = new Array();
    //
    var tempDragKey;
    var tempDropKey;
    var tempkey;
    var assetsLoaded = false;
    var quizLayout = '2 Column';
    var currentObjFocus;
    totalAttempts = 0;
    var lang;
    var optMoved = false;
    var DropListContainer;
    var DropListArray = [ "1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","Home"];
    var DropListAriaLabel = [  
         "Sequence 1",
         "Sequence 2",
         "Sequence 3",
         "Sequence 4",
         "Sequence 5",
         "Sequence 6",
         "Sequence 7",
         "Sequence 8",
         "Sequence 9",
         "Sequence 10",
         "Sequence 11",
         "Sequence 12",
         "Sequence 13",
         "Sequence 14",
         "Sequence 15",
         "Home"
      ];

    var clickTouchInst;

    app.init = function() {
        
        if (!assetsLoaded) {
            generatePreloader();
            preloadImages();
            return false;
        }

        clickTouchInst = isMobile() ? "Double tap": "Press enter or spacebar key";


        var myLanguage = config.data.lang;
        if(typeof myLanguage == 'undefined'){
            myLanguage = 'English';
        }
        lang = LangConst.languages[myLanguage];
        
        if (config.data.total_attempts)
        {
            activityTotalAttempts = Number(config.data.total_attempts)
        }

        totalAttempts = 0;        
        nSlideCounter = 0;
        aSlidesArray=[];
        OptionArray = [];
        maincontainer = $('#maincontainer');
        maincontainer.empty();
        Widget.setParameters();
        createObjects();
        var dropspotWidth = $($('.dropspot')[0]).width();
        var dropspotHeight = $($('.dropspot')[0]).height();
        $('.dragspotWrapper').css("width", dropspotWidth+'px');
        //$('.dragspotWrapper').css("height", dropspotHeight+'px');
        $('.dragspotWrapper').css("height", '75px');
        $('.dragspot').css("width", dropspotWidth+'px');
        $('.dragspotWrapper .dragspot').css("height", '75px');

        if(config.data.dnd1_activity_type == 'image'){
            $('.dragspot').css({width:"100px", "padding":'0px', "height":'100px'});
            $('.dropspot').css({width:"100px", "padding":'0px', "height":'100px'});
            $('.dragspot_txt').css({"padding":'0px'});
            $('.qlabel').css({"width":'100px', "height":'100px'});
        }
        if(config.data.dnd1_activity_type == 'both'){
            $('.dragspot').css({"padding":'10px'});
            $('.draglabel').css({"height":'100px'});
            $('.qlabel').css({"width":'100px',"height":'100px'});
            $('.qdraglabel img').css({"width":'80px',"height":'80px'});
            $('.qdraglabel').css({"width":'80px',"height":'80px'});
        }
        //Widget.setParameters();
        Widget.updateFrames();
        addEvents();
        makeDraggable();
        makeDroppable();
        addTabIndex();
        displayReadMoreIcon();
        detectDevice();
        /*var quizHeight = $(window).innerHeight() - ($('.bottom-container').height()+$('#title').height()+$('.drag_tray').height()+$('.qtitle img').height());
        setTimeout(function(){
            parentBottomOffset = window.parent.$('.bottom-container').offset().top;
            var quizHeight = parentBottomOffset - ($('#title').height()+$('.drag_tray').height()+$('.qtitle img').height()+60);
            $('#quiz-container').css({'height' :quizHeight+'px'});
        }, 200);*/
        if(!isMobile())
            $('.titletext').focus();
    }
    app.preloadingDataComplete = function() {
        assetsLoaded = true;
        Widget.init();
    }
    function createObjects() {
        document.title = config.data.title;
        title = $('<div>', {id:'title', class:''});
        titleHeading = $('<h1>', {class:'titletext', 'tabindex':'-1'});
        titleHeading.append(config.data.title);
        title.append(titleHeading);

        if(config.data.title_audio != ''){
            titleAudio = $("<a href='javascript:void(0)' data-src='audio/"+config.data.title_audio+"' class='audio audio_title' aria-hidden='true' tabindex='-1'><img src='../../images/audio_white.svg' alt='' /></a>");
            title.append(titleAudio);
        }
        
        helpHint = $('<span>', {class:'helpHint', id: 'helpHintText'});
        helpHintHref = $('<div>', {class:'helpHintLink tabindex', 'aria-label':'About this activity. '+clickTouchInst+' to open About this Activity pop up.', 'role': 'button'});
        helpHintImage = $('<img>', {src:'../../images/info.svg', 'title': lang.aboutThisActivity,'alt': lang.aboutThisActivity});
        helpHintHref.append(helpHintImage);
        helpHint.append(helpHintHref);

        if(config.data.hint_type.length){
            title.append(helpHint);
        }
        questionWrapper = $('<div>', {id:'questionWrapper'});
        
        qtitle = $('<div>', {class:'qtitle'});
        qtitle_image = $('<div>', {class:'qtitle_image'});
        if(config.data.avatar_in_active != ''){
            qtitle_image.append('<div class="avatar_popup" role="button"><img alt="'+config.data.avatar_alt_text+'" title="'+lang.Hint+'" src="images/'+config.data.avatar_in_active+'" data-src="audio/'+config.data.avatar_audio+'" class="qimage"/></div>');
        }
        var question_txt = config.data.question_text.replace(/\n/g, "<br />");
        if(config.data.question_audio != ''){
            question_txt += '<a href="javascript:void(0);" data-src="audio/'+config.data.question_audio+'" class="audio audio_avatartxt noTab" tabindex="-1", aria-hidden="true"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></a>';
        }
        var qtitletext ='<p class="avatar_text">'+question_txt+'</p>';
        var clearDiv1 = $('<div>', {'style':'clear:both;'});
        qtitle.append(qtitle_image);
        qtitle.append(qtitletext);
        qtitle.append(clearDiv1);
        
        var justDiv = $('<div>', {'style': 'clear:both;'});
        quizContainer = $('<div>', {id: 'quiz-container',class: 'quiz-container',tabindex: -1});
        helpHintContainer = $('<div>', {class: 'help-hint-container'});
        var dropspot;
        var hint_visibility = 'visible';
        for(var i = 0; i < config.data.options.length; i++) {
            var qlabelClass = '';
            if(config.data.assets[i] == ''){
               qlabelClass = ' visibleHidden'; 
            }
            var dropspotstr = '<div class="quiz'+i+' quiz"> \
                <div class="draglabel responsive_col">  \
                <div class="qlabel'+qlabelClass+'"> \
                    <img src="images/'+config.data.assets[i]+'" class="noTab" alt="'+(i+1)+'. '+config.data.asset_alt_text[i]+'">';
            if(config.data.show_numbers == 'true')
                dropspotstr += '<span class="qnumber">'+config.data.drop_txt_labels[i]+'</span>';
                dropspotstr += '<div aria-label="'+config.data.asset_alt_text[i]+' zoom image. '+clickTouchInst+' to open zoom image." class="zoomImg tabindex" data-src="images/'+config.data.assets[i]+'" alt="'+config.data.asset_alt_text[i]+'" role="button"><img src="../../images/zoom.svg" alt="Zoom image" /></div> \
                </div> \
                <div><span class="dropspot" id="drop_item_'+i+'"  aria-dropeffect="none" aria-label="'+config.data.asset_alt_text[i]+'" dropped="false" data-answer="'+i+'"> </span>\
                </div>';
            
            if(config.data.option_hint[i] == ''){
                hint_visibility = 'notvisible';
            } else {
                hint_visibility = 'visible';
            }

            dropspotstr += '<div aria-label="open option hint" role="button" class="qhint tabindex '+hint_visibility+'" data-option-id="'+i+'"><img src="../../images/hint.svg" alt="Hint"/></div>';
            dropspotstr +=  '<span class="fbhint incorrect hide" title="Incorrect Answer"><img src="../../images/wrong_ans.svg" alt="Incorrect Answer"/></span>\
                <span class="fbhint correct hide" title="Correct Answer"><img src="../../images/right_ans.svg" alt="Correct Answer"/></span>\
                </div>  \
            </div>';
            dropspot = $(dropspotstr);
            quizContainer.append(dropspot);
        }

        drag_Tray = $('<div>',{class:'drag_tray'});
        DragInstructions = '<p class="screenhide dragstart" aria-label="Select a name and drop it on the input field of its related category by pressing Enter key."> &nbsp;</p>';
        drag_Tray.append(DragInstructions);

        answerContainer = $('<div>', {class:'answer-container'});       
        $(drag_Tray).append(answerContainer);
        //Add frames to dragspot         
        createFrames();
        answerContainer.append(DragSet);
        $(questionWrapper).append(qtitle);
        $(questionWrapper).append(justDiv)
        $(questionWrapper).append(drag_Tray);       
        $(questionWrapper).append(quizContainer);

        var clearDiv = $('<div>', {'style':'clear:both;'});

        bottomContainer = $('<div>', {class:'bottom-container', id:'page-bottom-container'});
        buttonContainer = $('<div>', {class:'button-container'});
        submitButton = $('<button>', {class:'submit disabled tabindex', type:'button', disabled:'disabled'}).bind('click keydown', checkAnswer);
        submitButton.append(lang.Checkanswers);

        showcorrectButton = $('<button>', {class:'correctbtn disabled hide tabindex', type:'button', disabled:'disabled'}).bind('click keydown',showCorrectAnswer);
        showcorrectButton.append(lang.ShowCorrectAnswers);

        buttonContainer.append(submitButton);
        buttonContainer.append(showcorrectButton);

        showMyAnsButton = $('<button>', {class:'myanswerbtn disabled hide tabindex', type:'button', disabled:'disabled'}).bind('click keydown',showMyAnswer);
        showMyAnsButton.append(lang.ShowMyAnswers);
        buttonContainer.append(showMyAnsButton);

        resetButton = $('<button>', {class:'reset disabled tabindex',  type:'button', disabled:'disabled'}).bind('click keydown',resetAnswer);
        resetButton.append(lang.Reset);
        buttonContainer.append(resetButton);

        maincontainer.append(title);
        maincontainer.append(questionWrapper);
        maincontainer.append(clearDiv);
        
        bottomContainer.append(buttonContainer);
        maincontainer.append(bottomContainer);

        $(drag_Tray).prepend('<div class="leftArrow leftArrowDisable tabindex" role="button"><img src="../../images/arrow_left_draggable.svg" alt="Left Arrow" /></div>');
        $(drag_Tray).append('<div class="rightArrow tabindex" role="button"><img src="../../images/arrow_right_draggable.svg" alt="Right arrow" /></div>');

        $(".answer-container .frame").each(function() {
            $(this).css('display', 'none')
            aSlidesArray.push($(this))
            nCount++;
        });
        $(".answer-container .headerFrame0").show();

        $('.submit').attr('aria-label',lang.Checkanswer+'. '+clickTouchInst+' to check your answer.');
        $('.myanswerbtn').attr('aria-label',lang.ShowMyAnswers+'. '+clickTouchInst+' to show your answer.');
        $('.correctbtn').attr('aria-label',lang.ShowCorrectAnswer+'. '+clickTouchInst+' to show correct answer.');
        $('.reset').attr('aria-label','Reset. '+clickTouchInst+' to Reset the Quiz.');


        fnCheckNextBack();
    }
    function zoomTextModal(e){
        openHint(e,$(this), 'zoomText'); 
        e.preventDefault();      
        e.stopPropagation();
        e.stopImmediatePropagation();
    }
    function addEvents(){
        $(".qlabel .zoomImg").unbind().bind('click keydown touchstart', imageModal);
        $(".qdraglabel .zoomImg").unbind().bind('click keydown touchstart', imageModal);
        $(".qhint").bind('click keydown touchstart', function(e){
            openHint(e,$(this), 'optionHint');
        });
        $(".dragspot .zoomTextButton").unbind().bind('click touchstart keydown touchstart', zoomTextModal);
        
        $(".helpHintLink").bind('click keydown touchstart', function(e){
            openHint(e,$(this), 'helpHint');
        });
        $(".audio").unbind().bind('click keydown touchstart', common.playAudio);
        // $(".audio").attr('aria-label', 'Press space or enter to play audio');
        $(".avatar_popup").bind('keydown click', common.avtarPopup);
        $(".avatar_popup").bind('keydown click', common.playAudio);
        $('.leftArrow').bind('click keydown',fnBack);
        $('.rightArrow').bind('click keydown',fnNext);
        $(".rightArrow").attr('aria-label', 'Next tiles. '+clickTouchInst+' to move to next tiles list.').attr('title', 'Next tiles');
        $(".leftArrow").attr('aria-label', 'Previous tiles. '+clickTouchInst+' to move to previous tiles list.').attr('title', 'Previous tiles');
        $(".dragspotWrapper .dragspot").bind('keydown',handleDragByKey);
        $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        $(".dropspot").bind('click touchend', handleDropByClick);

        $(".quiz-container").bind('touchmove',handleScrollPaneTouchMove);
    }
    function imageModal(e){
        if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
        {}else{
            e.preventDefault();
            e.stopImmediatePropagation();
            e.stopPropagation();
            currentObjFocus = $(this);
            $('body').addClass('stop-scrolling');
            var $modal = $('<div id="myModal" class="modal">\
             <div class="modal-content">\
                <p class="screenhide screenstart" aria-label="pop-up content starts">&nbsp;</p> \
                <img class="modalImage" alt="'+$(this).attr("alt")+'" src="'+$(this).attr("data-src")+'"/>\
                <p class="screenhide screenend" aria-label="pop-up content ends">&nbsp;</p> \
                <div class="modalClose" aria-label="Close Popup" role="button"><img alt=""  src="../../images/close_image_popup.svg" /></div> \
            </div>\
            </div>');
            $("body").append($modal);
            $(".modalClose").bind("click keydown touchstart", function(e) {
                if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
                {}else{
                    $('body').removeClass('stop-scrolling');
                    maincontainer.removeAttr('aria-hidden');
                    addTabIndex();
                    setTimeout(function(){
                        currentObjFocus.focus();
                    },100);
                    $(this).parent().parent().remove();
                }
            });
            $modal.css("display", "block");
            currentTabIndex = $(this).attr('tabindex');
            removeTabIndex();
            $('.modalClose').attr('tabindex',0);
            //$('.modalImage').attr('tabindex',0);
            //$('.screenhide').attr('tabindex',0);
            maincontainer.attr('aria-hidden', true);
            setTimeout(function(){
                //$('#myModal .modalImage').focus();
                $('#myModal').focus();  
                $(document).find('body').addClass('show-focus-outlines');
            },200);
        }
    }
    function openHint(e, object, type){
    //if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
    if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
    {}else{
        e.preventDefault();
        e.stopImmediatePropagation();
        e.stopPropagation();

        currentObjFocus = object;
        var popupTitle;
        var hintString = '';
        var hintAudio = '';
        var modalClass;
        switch(type){
            case 'optionHint':
                popupTitle = lang.Hint;
                var option_id = $(object).attr('data-option-id');
                hintString = config.data.option_hint[option_id];
                hintAudio = config.data.opt_hint_audio[option_id];
                modalClass = 'qhintpopup';
                if(config.data.opt_hint_audio[option_id] != '')
                    hintAudio = '<div data-src="audio/'+config.data.opt_hint_audio[option_id]+'" class="audio audio_drag noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></div>';
            break;
            case 'helpHint':
                popupTitle = lang.aboutThisActivity;
                var hint_str = '';
                for(var h = 0; h< config.data.hint_type.length; h++){
                    hintString += '<p class="tooltip_popupContent" aria-label="'+config.data.hint_text_image[h]+'">';
                    if(config.data.hint_type[h] == 'image') {
                        hint_str = '<img src="images/'+config.data.hint_text_image[h]+'" alt="'+config.data.hint_audio_alt[h]+'" style="max-width: 100%;" />';
                    }else{
                        hint_str = ' '+config.data.hint_text_image[h]+' ';
                        if(config.data.hint_audio_alt[h] != ''){
                            hint_str += '<span data-src="audio/'+ config.data.hint_audio_alt[h] + '" class="audio audio_about_activity noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></span>';
                        }
                    }
                    hintString += hint_str;
                    hintString+= '</p>';
                }
                modalClass = 'hint_and_tips';
                hintAudio = config.data.hint_tips_audio;
            break;
            case 'zoomText':
                modalClass = 'hint_and_tips';
                popupTitle = '';
                var popupContents = $(object).parents(".dragspot").find(".dragspot_txt").html();
                //var result = popupContents.replace(/(<a[^>]+?>|<a>|<\/a>)/img, "");
                var result = $(object).parents(".dragspot").find(".dragspot_txt").attr("data-baseText");
                hintString += '<p class="tooltip_popupContent">'+result+'</p>';
                hintAudio =  ($(object).parents(".dragspot").find(".audio").length > 0) ? '<div data-src="'+$(object).parents(".dragspot").find(".audio").attr("data-src") + '" class="audio audio_drag noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></div>' : '';
            break;
        }

        
        var popupImg = (type == 'zoomText') ? 'close_callout' : 'close_white' ;
        var popupHeader = (type == 'zoomText') ? '' : '<div class="modalImage"> </div> <h1 class="popupHeader" id="inst_dialog_label">'+ popupTitle + '</h1>';

            var hintAudiostr = '';
            if(hintAudio != '')
                var hintAudiostr = '<div data-src="audio/'+ hintAudio + '" class="audio audio_hintPopup noTab" aria-hidden="true"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt="" /></div>';

            var $modalDiv = $('<div id="myHintModal" class="modal" role="dialog" aria-labelled="inst_dialog_label popup_content_body" tabindex="-1">\
                <div class="tooltip-model-content '+modalClass+'"> \
                    '+popupHeader+' \
                    <div class="hintpopupContent">'+ hintString + ' '+hintAudio+'</div> \
                  <div class="tooltipModalClose tabindex" role="button" aria-label="Close Popup. '+clickTouchInst+' to close the popup."><img alt="" src="../../images/'+popupImg+'.svg" /></div>\
                </div> \
                </div>');
            $("body").append($modalDiv);


            $(".tooltipModalClose").bind("click keydown touchstart", function(e) {
                if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
                {
                }else{
                    common.stopAudio();
                    $('body').removeClass('stop-scrolling');
                    $(this).parent().parent().remove();
                    addTabIndex();
                    setTimeout(function() {
                        currentObjFocus.focus();
                    }, 100);
                    maincontainer.removeAttr('aria-hidden');
                }
            });
            $modalDiv.css("display", "block");
            currentTabIndex = object.attr('tabindex');
            removeTabIndex();
            //$(".audio").attr('aria-label', 'Press space or enter to play audio');
            //$('#myModal .popupHeader').attr('tabindex',0);
            $("#myModal .helpPopupImg").attr("tabindex",0);
            //$('#myModal .audio').attr('tabindex',0);
            //$('#myModal .screenhide').attr('tabindex',0);
            $('tooltipModalClose').attr('tabindex',0);

            if(e.type === 'keydown'){
                $(document).find('body').addClass('show-focus-outlines');
            }
            setTimeout(function() {
                $('#myHintModal').focus();
            }, 100);

            maincontainer.attr('aria-hidden', true);
            $(".audio").unbind().bind('click keydown touchstart', common.playAudio);
            $(".audio").attr("tabindex","-1");
            $(".tooltipModalClose").attr("tabindex","0");
        }
    }
    function makeDraggable(){
        $(function() {
         $( ".dragspotWrapper .dragspot" ).draggable({
            //cancel: ".dragspot .audio",
            handle: ".dragHandle",
            revert: function(dropped,ui) {
                tempDragKey = null;
                thisDropID = null;
                inTap = false;
                if(!(dropped) && $(this).parent().hasClass("dropspot")){
                var newDragspotWrapper = $('<li>', {class:'dragspotWrapper'}); 
                newDragspotWrapper.attr('data-id',$(this).attr('data-answer'));
                $(this).parent().attr("dropped","false");
                $(this).removeClass('correct incorrect-answer');
                newDragspotWrapper.append($(this));
                if($(".answer-container .frame").length > 0){
                    $(".answer-container .frame:nth-child(1)").prepend(newDragspotWrapper); 
                    if($(".dropspot .dragspot").length < 1){
                    $(".reset").addClass("disabled").attr("disabled","disabled");
                    }  
                }else{
                    if($(".answer-container .frame").length < 1){
                        var newFrame = $('<ol>', {class:'frame headerFrame0'});
                        newFrame.append(newDragspotWrapper);
                        $(".answer-container").append(newFrame);
                        submitButton.addClass('disabled');
                        submitButton.attr('disabled','disabled');
                    }                    
                }              
                app.updateFrames();
                addTabIndex();
                $(".dragspotWrapper .dragspot").bind('keydown',handleDragByKey);
                $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
            }else{
                if(correctDropped){
                    return false;
                }
                return true;
            }                  
        },
        containment: '#questionWrapper',
        reverting: function() {           
        },
        start: function(event, ui) {
            $('.dropspot[dropped="false"]').each(function(index) {
                if (!$('this').hasClass("correct")) {
                    $(this).attr("aria-dropeffect", 'move');
                }
            });
            $(this).attr("aria-grabbed", 'true');
            $('.avatar_tooltip .qhintClose').trigger('click');
            $(this).css('z-index', 10);
            tempParent = $(this).parent();
            if($(this).parent().hasClass('dragspotWrapper')) {

            }
            if($(this).parent().hasClass('dropspot')) {
                $(this).parent().attr("dropped", 'false');
            }
            ui.helper.data('original-position', ui.helper.offset());
            correctDropped = false;
        },
        drag: function() {
            if($(this).parent().hasClass("dropspot")){
                // $("#quiz-container").css({"overflow": "visible"});
                $(".quiz-container").css({"overflow-y":"visible"});

            }

        },
        stop: function(event, ui) {
            tempDragKey = null;
                thisDropID = null;
                inTap = false;
            $('.dropspot').attr("aria-dropeffect", 'none');
            $(this).attr("aria-grabbed", "false");
            var rejected = true;
            $('#quiz-container').css({"overflow-y": "scroll", "margin-right": "0px"});
            if(!correctDropped)  {
                if($(this).parent().hasClass('dragspotWrapper'))
                {
                    // $(this).parent().find('.placeholder').remove();
                }
                else{
                    $(this).parent().attr("dropped", 'true');
                }
            }
            if (rejected == true) {
                // ui.draggable.offset(ui.helper.data('original-position'));
            }
            setQuizContainerHeight();
            $(this).css('z-index', 1);
        }
     });
  });
}

function makeDroppable(){
        $( ".dropspot" ).droppable({
        classes: {
            "ui-droppable-active": "ui-state-active",
            "ui-droppable-hover": "ui-state-hover"
        },
        over: function(event, ui){
            var dataAnswer = parseInt($(this).attr('data-answer'));
            var factor = 0;
            var dataAnswer1 = dataAnswer;
            var scrollto = 0;
            if(quizLayout == '2 Column'){
                factor = 1;
                if(dataAnswer%2 == 1){
                    dataAnswer1 = dataAnswer-1;
                }
            }            
            if(dataAnswer1 == 0)
                scrollto = 0;
            else if((config.data.options.length - 1) == dataAnswer)
                scrollto = 1000;
            else
                scrollto = (dataAnswer1-factor) * $(this).height();
            //Quiz container scroll disabled. as per comments
            //   $("#quiz-container").animate({"scrollTop": scrollto});
            /*
                $('.drop_area').autoscroll({
                    direction: 'up',
                    step: 150,
                    scroll: true
                });
            */
        },
        drop: function( event, ui ) {
            tempDragKey = null;
            thisDropID = null;
            inTap = false;
            $('.dropspot').attr("aria-dropeffect", 'none');

            if ($(this).offset().top<$(".answer-container").offset().top+$(".answer-container").height())
            {
                return;
            }


            if(!$(this).children().hasClass("ui-draggable-disabled")){
                ui.draggable.unbind('keydown');
                $(this).removeClass('dotted-frame');
                var this_hasChild = $(this).children().length;
                ui.draggable.addClass('correct' );
                ui.draggable.position( { of: $(this)} );
                if(tempParent.parent().hasClass('frame') && this_hasChild == 0){
                    ui.draggable.appendTo($(this));
                    setConditionsToDragDrop($(this));
                    autoUpdatedDragBox();
                }else{
                    if((this_hasChild != 0 && tempParent.parent().hasClass('frame')) ){
                        tempParent.attr('data-id',$(this).children().attr('data-answer'));
                        $(this).children().removeClass('correct incorrect-answer');
                        tempParent.append($(this).children());
                        ui.draggable.appendTo($(this));
                        setConditionsToDragDrop($(this));

                    }else{
                        if(this_hasChild < 1){
                           ui.draggable.appendTo($(this));
                           setConditionsToDragDrop($(this)); 
                        }
                        if((tempParent.hasClass('dropspot') && this_hasChild == 1) && tempParent.children().attr('data-answer') != $(this).children().attr('data-answer') ){
                            var newDragspotWrapper = $('<li>', {class:'dragspotWrapper'}); 
                            newDragspotWrapper.attr('data-id',$(this).children().attr('data-answer'));
                            $(this).attr("dropped","false");
                            $(this).children().removeClass('correct incorrect-answer');
                            newDragspotWrapper.append($(this).children());
                            ui.draggable.appendTo($(this));                            
                            setConditionsToDragDrop($(this));
                            if($(".answer-container .frame").length > 0){
                                //$(".answer-container .frame:visible").prepend(newDragspotWrapper);
                                $(".answer-container .frame:nth-child(1)").prepend(newDragspotWrapper); 
                            }
                            else{                                     
                                if($(".answer-container .frame").length < 1){
                                    var newFrame = $('<ol>', {class:'frame headerFrame0'});
                                    newFrame.append(newDragspotWrapper);
                                    $(".answer-container").append(newFrame);
                                    submitButton.addClass('disabled');
                                    submitButton.attr('disabled','disabled');
                                }
                            }
                        }
                    }
                    app.updateFrames();
                }

                function setConditionsToDragDrop(thisDrop){
                    $(thisDrop).attr("dropped", 'true');
                    ui.draggable.css( {'top':'0px','left':'0px','position':'absolute'} );
                    correctDropped = true;
                    var correct_answer = $(thisDrop).attr('data-answer');
                    var dropped_answer = $(thisDrop).find('.dragspot').attr('data-answer');
                    if(correct_answer == dropped_answer) {
                        $(thisDrop).find('.dragspot').addClass('correct-answer');
                    }
                    else {
                        $(thisDrop).find('.dragspot').addClass('incorrect-answer');
                        var data_id = $(thisDrop).find('.dragspot').attr('data-id');
                        setTimeout(function() {
                            ui.draggable.removeClass('incorrect-answer'); 
                            ui.draggable.parent().addClass('dotted-frame');
                        }  , 1000 );
                    }
                    $('.dropspot .dragspot').unbind('keydown').bind('keydown', handleRemoveDragByKey);
                    $('.dropspot .ui-draggable-disabled').unbind('keydown');
                    $('.dropspot .dragspot').css('min-width', 'auto');
                    element = thisDrop;
                    var eleWidth = element.width(),
                    eleHeight = element.height(),
                    ntext = element.find('.dragspot_txt').length,
                    ndraglabel = element.find('.qdraglabel').length,
                    vDragspotTextEle = element.find('.dragspot_txt'),
                    vDragspotImageEle = element.find('.qdraglabel');
                    
                    element.find('.dragspot').css('max-height', 'initial');
                    if(config.data.dnd1_activity_type == 'both'){
                        // Image with text
                        vDragspotTextEle.css({'display':'block','padding':'0px'});
                        //var txtWidth = vDragspotTextEle.width()-25;
                        var txtWidth = $(thisDrop).parents('.dropspot').width()-vDragspotImageEle.width();
                        vDragspotTextEle.css('width', txtWidth+'px');
                        vDragspotImageEle.css({'margin':'0px 10px 0px 0px'});
                        if($(window).innerWidth() < 500) {
                            vDragspotImageEle.css({'width':'62px', 'height':'62px','margin-top':'0px'});
                            vDragspotImageEle.find('img').css({'width':'60px', 'height':'60px'});
                            vDragspotTextEle.css('padding-left', '0px');
                            element.find('.dragspot').css({'padding':'10px'});
                            var txtWidth = $(thisDrop).width()-vDragspotImageEle.width()-50;
                            vDragspotTextEle.css('width', txtWidth+'px');
                       }
                       else{
                            element.find('.dragspot').css({'padding':'10px'}); 
                       }
                       var ndragspotHeight = element.find('.dragspot').height();
                       if(vDragspotTextEle.height() < (ndragspotHeight - 20)){
                            element.find('.zoomTextButton').css('display','none');
                       }
                    }
                    //else if(ntext > 0 && ndraglabel == 0){
                    if(config.data.dnd1_activity_type == 'text'){
                       // text only
                       if(eleHeight > document.getElementById(vDragspotTextEle.attr('id')).scrollHeight){
                            // space available
                            vDragspotTextEle.css('max-height','100%');
                            element.find('.zoomTextButton').css('display','none');
                       }
                       else{
                            vDragspotTextEle.css('max-height','100%');
                       }
                       if(document.getElementById(vDragspotTextEle.attr('id')).scrollHeight == 0){
                             element.find('.zoomTextButton').css('display','none');
                       }
                    }
                    if(config.data.dnd1_activity_type == 'image'){
                        // image only
                       /* if($(window).innerWidth() < 500){
                            vDragspotImageEle.css({'width':'62px', 'height':'62px','margin-top':'25px'});
                            vDragspotImageEle.find('img').css({'width':'60px', 'height':'60px'});
                        }*/
                    }
                    displayReadMoreIcon();
                }
            }
        resetButton.removeClass('disabled');
        resetButton.removeAttr('disabled').attr("tabindex","0");;
        addTabIndex();
        $(".dragspotWrapper .dragspot").unbind('keydown').bind('keydown',handleDragByKey);
        $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        var all_dropped = true;
        $('.dropspot').each(function(){
            if($(this).attr("dropped") != 'true')
                all_dropped = false;
        });
        all_correct = true;
        $(".dropspot").each(function(){
            var correct_answer = $(this).attr('data-answer');
            var dropped_answer = $(this).find('.draggable').attr('data-answer');
            if(correct_answer != dropped_answer) {
                all_correct = false;
            }
        });
        if(all_dropped) {
            submitButton.removeClass('disabled');
            submitButton.removeAttr('disabled').attr("tabindex","0");;
            if(all_correct) {
                $('.try-again-btn').show();
                $('.congratulations').show();
            }
        }
        if(!$('.answer-container .dragSpotWrapper .dragSpot').length){
            DisableLeftArrow();
            DisableRightArrow();
        }
    }
    });
    }
    function displayReadMoreIcon() {
        $('.answer-container .dragspot_txt').css('max-height','93px');
        $('.answer-container .dragspot_txt').each(function(){
            $(this).parents('.dragspot').css('padding', '0px');
            $(this).css({
                'display':'block',
                'overflow':'hidden',
                'padding':'3px 23px 10px 5px',
                'float':'left'
            });
            $(this).parents('.dragspot').css({'min-width':'200px','display':'inline-block','padding':'0px'});
            $(this).parents('.dragspotWrapper').css({'min-width':'200px'});
            $(this).parents('.dragspot').find('.qdraglabel').css({'float':'left','margin':'10px','margin-right':'0px'});
            if(!$(this).parents('.dragspot').find('.qdraglabel').length)
            {
                $(this).css({'width':'90%'});
            }
            else{
                $(this).parents('.dragspot').find('.qdraglabel').css({'width':'82px', 'height':'82px'});
                $(this).parents('.dragspot').find('.qdraglabel img').css({'width':'80px', 'height':'80px'});
                var imgwidth = $(this).parents('.dragspot').find('.qdraglabel').width();
                var parentWidth = $(this).parents('.dragspot').width();
                var txtWidth = parentWidth - imgwidth-25;
                if($(window).innerWidth() < 500)
                    txtWidth = parentWidth - imgwidth-25;
                $(this).css({'width':txtWidth+'px', 'padding-left':'0px'});   
            }
            var numberOflines = getRows($(this));
        
    var ntext = $(this).parents('.dragspot').find('.dragspot_txt').length,
    ndraglabel = $(this).parents('.dragspot').find('.qdraglabel').length;
    vDragspotImageEle = $(this).parents('.dragspot').find('.qdraglabel');
    $(this).parents('.dragspot').css('max-height', 'initial');
    if(ntext > 0 && ndraglabel > 0) {
        // Image with text
        $(this).css({'display':'block','padding':'0px'});
        var txtWidth = $(this).parents('.dragspot').width()-$(this).parents('.dragspot').find('.qdraglabel').width()-45;
        $(this).css('width', txtWidth+'px');
    }
    else if(ndraglabel > 0){
        // Image only
        /*$(this).parents('.dragspot').find('.qdraglabel').css({'width':'100%'})
        $(this).parents('.dragspot').css({'min-width':'auto'})*/
    } else{
        //text only
        if($(window).innerWidth() < 500)
            $(this).css({ 'padding':'0px 23px 0px 5px'});
    }
        $(this).parents('.dragspot').find('.zoomTextButton').css('display','none');
        if(numberOflines > 3) {
            $(this).parents('.dragspot').find('.zoomTextButton').css('display','block');
        }
    }); 

        $('.quiz-container .dragspot_txt').css('max-height','93px');
        $('.quiz-container .dragspot_txt').each(function(){
            $(this).parents('.dragspot').css('padding', '0px');
            $(this).css({
                'display':'block',
                'overflow':'hidden',
                'padding':'3px 23px 10px 5px',
                'max-height':'90px',
                'float':'left'
            });
            $(this).parents('.dragspot').css({'min-width':'200px','display':'inline-block','padding':'0px'});
            $(this).parents('.dragspot').find('.qdraglabel').css({'float':'left','margin':'10px','margin-right':'0px'});
            if(!$(this).parents('.dragspot').find('.qdraglabel').length)
            {
                $(this).css({'width':'90%'});
            } else{
                $(this).parents('.dragspot').find('.qdraglabel').css({'width':'82px', 'height':'82px'});
                $(this).parents('.dragspot').find('.qdraglabel img').css({'width':'80px', 'height':'80px'});
                var imgwidth = $(this).parents('.dragspot').find('.qdraglabel').width();
                var parentWidth = $(this).parents('.dragspot').width();
                var txtWidth = parentWidth - imgwidth-25;
                if($(window).innerWidth() < 500){
                    txtWidth = parentWidth - imgwidth-25;
                }
                $(this).css({'width':txtWidth+'px', 'padding-left':'0px'});   
            }
            var numberOflines = getRows($(this));
        
    var ntext = $(this).parents('.dragspot').find('.dragspot_txt').length,
    ndraglabel = $(this).parents('.dragspot').find('.qdraglabel').length;
    vDragspotImageEle = $(this).parents('.dragspot').find('.qdraglabel');
    $(this).parents('.dragspot').css('max-height', 'initial');
    if(ntext > 0 && ndraglabel > 0) {
        // Image with text
        $(this).css({'display':'block','padding':'0px'});
        var txtWidth = $(this).parents('.dragspot').width()-$(this).parents('.dragspot').find('.qdraglabel').width()-45;
        $(this).css('width', txtWidth+'px');
    } else if(ndraglabel > 0){
        // Image only
    } else{
        //text only
        if($(window).innerWidth() < 500)
            $(this).css({ 'padding':'0px 23px 0px 5px'});
    }
    $(this).parents('.dragspot').find('.zoomTextButton').css('display','none');
    if(window.innerWidth <= 600 ) {
        if(numberOflines >= 4) {
            $(this).parents('.dragspot').find('.zoomTextButton').css('display','block');
        }
    } else{
        if(numberOflines > 4) {
            $(this).parents('.dragspot').find('.zoomTextButton').css('display','block');
        }
     }
    });
        $('.answer-container .qdraglabel').each(function(){
            $(this).css({'width':'82px', 'height':'82px', 'margin':'10px'});
            $(this).find('img').css({'width':'80px', 'height':'80px'});
            if($(this).parents('.dragspot').find('.dragspot_txt').text() == '') {
                //image only tiles
                $(this).css({'margin':'auto','float':'none','width':'100%', 'height':'100%'});
                $(this).find('img').css({'width':'100%', 'height':'100%'});
                $(this).parent().css({'min-width':'auto'});
                $(this).parent().parent().css({'min-width':'auto'});
            }
        });
        $(".dragspot .zoomTextButton").unbind().bind('click keydown touchstart', zoomTextModal);
        $('.dropspot .dragspot').css('min-width', 'auto');
    }

    function getRows(selector) {  
        var elementId = $(selector).attr('id');
        var height = (document.getElementById(elementId).scrollHeight - 20);
        var line_height = $(selector).css('line-height');
        line_height = parseFloat(line_height)
        var rows = height / line_height;
        return rows;
        //return Math.round(rows);
    }

    function showCorrectAnswer(e){
        if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
        {}else{
            var dataAnswer;
            $('.fbhint.correct').removeClass('hide');
            $('.fbhint.incorrect').addClass('hide');
            $(".dropspot").each(function(){
                dataAnswer = $(this).attr('data-answer');
                $(this).attr('dropped', true);
                $(this).append($('.dragspot[data-answer="'+dataAnswer+'"]'));
                $('.dragspot[data-answer="'+dataAnswer+'"]').addClass("highlightMe");
            });
            $(this).addClass('disabled hide');
            $(this).attr('disabled', 'disabled');
            showMyAnsButton.removeClass('disabled hide');
            showMyAnsButton.removeAttr('disabled').attr("tabindex","0");
            setTimeout(function(){
                showMyAnsButton.focus();
            }, 200);
        }
    }
    function showMyAnswer(e){
        if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
        {}else{
            $('.fbhint').show();
            var i = 0;
            var dataAnswer;
            var dropped_answer;
            $(".dropspot").each(function(){
                dataAnswer = userAnswers[i];
                $(this).attr('dropped', true);
                $(this).append($('.dragspot[data-answer="'+dataAnswer+'"]'));
                $('.dragspot[data-answer="'+dataAnswer+'"]').removeClass("highlightMe");
                i++;
            });
            $(".dropspot").each(function(i){
                dataAnswer = $(this).attr('data-answer');
                dropped_answer = $(this).find('.dragspot').attr('data-answer');
                if(dataAnswer == dropped_answer) {
                    $(this).parents(".draglabel").find('.fbhint.correct').removeClass('hide');
                    $(this).parents(".draglabel").find('.fbhint.incorrect').addClass('hide');
                }
                else {
                    $(this).parents(".draglabel").find('.fbhint.incorrect').removeClass('hide');
                    $(this).parents(".draglabel").find('.fbhint.correct').addClass('hide');
                }
            });
            $(this).addClass('disabled hide');
            $(this).attr('disabled', 'disabled');
            showcorrectButton.removeClass('disabled hide');
            showcorrectButton.removeAttr('disabled').attr("tabindex","0");
             setTimeout(function(){
                showcorrectButton.focus();
            }, 200);
         }
    }
    function checkAnswer(e){
        if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
        { }else{
            var current = 0;
            var audioPopup;
            all_correct = true;
            var imageSrc = '';
            totalAttempts++;
            userAnswers = [];
            var feedback_header_color;
            $(".dropspot").each(function(){
                var correct_answer = $(this).attr('data-answer');
                var dropped_answer = $(this).find('.dragspot').attr('data-answer');
                userAnswers.push(dropped_answer);
                if(correct_answer == dropped_answer) {
                    $(this).parents(".draglabel").find('.fbhint.correct').removeClass('hide');
                    $(this).parents(".draglabel").find('.fbhint.incorrect').addClass('hide');
                } else {
                    $(this).parents(".draglabel").find('.fbhint.incorrect').removeClass('hide');
                    $(this).parents(".draglabel").find('.fbhint.correct').addClass('hide');
                    all_correct = false;
                }
                current++;
            });
            resetButton.removeClass('disabled');
            resetButton.removeAttr('disabled').attr('tabindex',0);
            $(this).addClass('disabled');
            $(this).attr('disabled', true);
            // quizContainer.find('.fbhint').removeClass('hide');
            if(all_correct) {
                feedback_header_color = 'Correct';
                popupTitle = config.data.correct_feedback_head;
                popupContent = config.data.correct_feedback;
                audioPopup = config.data.correct_feedback_audio;
                imageSrc = '../../images/right_ans.svg';
                totalAttempts = 0;
            } else { 
                feedback_header_color = 'Incorrect';          
                if(totalAttempts == 1){
                    popupTitle = config.data.incorrect_feedback1_head;
                    popupContent = config.data.incorrect_feedback1;
                    audioPopup = config.data.incorrect_feedback1_audio;
                }
                if(totalAttempts == 2){
                    popupTitle = config.data.incorrect_feedback2_head;
                    popupContent = config.data.incorrect_feedback2;
                    audioPopup = config.data.incorrect_feedback2_audio;                
                }
                if(totalAttempts == 3){
                    popupTitle = config.data.incorrect_feedback3_head;
                    popupContent = config.data.incorrect_feedback3;
                    audioPopup = config.data.incorrect_feedback3_audio;               
                }
                imageSrc = '../../images/wrong_ans.svg';
            }
            var audioString = '';
            if(audioPopup != '')
                audioString = '<div data-src="audio/'+audioPopup+'" class="audio noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></div>';
            $('body').addClass('stop-scrolling');
            // var $tooltip = $('<div id="myModal" class="modal">\
            //  <div class="feedback_modal_content"> \
            //     <h1 class="feedback_header '+feedback_header_color+'">'+ popupTitle + '</h1> \
            //     <p class="popupContent">'+ popupContent + '</p> '+audioString+' \
            //     <a href="javascript:void(0)" class="question_feedback_close" title="Close Popup"><img src="../../images/close_callout.svg" alt="Close" /></a>  \
            //   </div>  \
            // </div> ');

            var $tooltip = $('<div id="fdbModal" class="modal tabindex" role="dialog" aria-labelledby="feedback_header popupContent">\
                 <div class="feedback_modal_content"> \
                    <h1 class="feedback_header ' + feedback_header_color + '"><img src="'+imageSrc+'" alt="" style="width: 22px;" /> <div class="header_txt">'+ popupTitle + '</div></h1> \
                    <p class="popupContent">'+popupContent+'</p>' + audioString + '  \
                    <div class="question_feedback_close tabindex" role="button" title="Close Popup. '+clickTouchInst+' to close the popup."><img src="../../images/close_callout.svg" alt="" /></div>  \
                </div>  \
                </div>');

            $('body').append($tooltip);
            $(".audio").unbind().bind('click keydown touchstart', common.playAudio);
            // $(".audio").attr('aria-label', 'Press space or enter to play audio');
            $(".question_feedback_close").bind("click keydown touchstart", function(e) {
                if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32)){
                    return false;
                }
                common.stopAudio();
                $('body').removeClass('stop-scrolling');
                maincontainer.removeAttr('aria-hidden');
                $(this).parent().parent().remove();
                $('#fdbModal').remove();
                //If 3 wrong attempts user will have option to see toggle answers and user answers.
                if(totalAttempts == activityTotalAttempts){
                    showcorrectButton.removeClass('disabled hide');
                    showcorrectButton.removeAttr('disabled').attr("tabindex","0");;
                    resetButton.removeAttr('disabled').attr("tabindex","0");
                    submitButton.addClass('disabled hide');
                    submitButton.attr('disabled', 'disabled');
                    $('.dragspot').draggable({disabled: true});
                    setTimeout(function(){
                        showcorrectButton.focus();
                    }, 100);
                    return false;
                }
                //Set width and height of dragspot as that of dropspot            
                //Revert incorrect options to origional position.
                revertIncorrectOptions();
                var dropspotWidth = $($('.dropspot')[0]).width();
                var dropspotHeight = $($('.dropspot')[0]).height();
                $('.dragspotWrapper').css("width", dropspotWidth+'px');
               // $('.dragspotWrapper').css("height", dropspotHeight+'px');
                $('.dragspotWrapper').css("height", '75px');

                displayReadMoreIcon();
                addTabIndex();

                if(e.type === 'keydown'){
                    $(document).find('body').addClass('show-focus-outlines');
                }
                if($(".answer-container .dragspot").length > 0){
                    setTimeout(function(){
                        $($('#maincontainer .dragspot')[0]).focus();
                    }, 100);
                }
               if(all_correct){
                    setTimeout(function(){
                        resetButton.focus();
                    }, 100);
               }
               addTabIndex();
               setQuizContainerHeight();
            });
            removeTabIndex();
            $('.submit').addClass('disabled');
            $tooltip.css("display", "block");
            currentTabIndex = $(this).attr('tabindex');
            //$('.feedback_modal_content .feedback_header').attr('tabindex',0);
            // $('.feedback_modal_content .popupContent').attr('tabindex',0);
            //$('.feedback_modal_content .audio_blue').attr('tabindex',0);
            $('.question_feedback_close').attr('tabindex',0);
            if(e.type === 'keydown'){
                $(document).find('body').addClass('show-focus-outlines');
            }
            
            $(".audio").attr("tabindex","-1");
            maincontainer.attr('aria-hidden', true);
            
            setQuizContainerHeight();
            displayReadMoreIcon();

            resetButton.attr('tabindex',-1);

            $('#fdbModal').attr('tabindex',0);
            setTimeout(function(){
                $('#fdbModal').focus();
            }, 200);
            tempDragKey = null;
            thisDropID = null;
            inTap = false;
        }
    }
    function resetAnswer(e){
        if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
        {}else{
            Widget.init();
            return false;
        }
    }
    function revertIncorrectOptions(){
        incorrectArray = [];
        incorrectOptions = [];
        incorrectDataLabel = [];
        incorrectDataLabelBy = [];
        quizContainer.find('.fbhint.incorrect').addClass('hide');
        $('.dropspot .dragspot').each(function(){
            var dropped_answer = $(this).attr('data-answer');
            var correct_answer = $(this).parent().attr('data-answer');
            if(correct_answer != dropped_answer) {
                incorrectArray.push($(this).html());
                
                if ($(this).attr("aria-label")){
                    incorrectDataLabel.push($(this).attr("aria-label"));
                }else{
                    incorrectDataLabel.push("");
                }
                if ($(this).attr("aria-labelledby")){
                    incorrectDataLabelBy.push($(this).attr("aria-labelledby"));
                }else{
                    incorrectDataLabelBy.push("");
                }
                
                incorrectOptions.push($(this).attr('data-answer'));
                $(this).parent().attr("dropped","false");
                $(this).remove();
            }
            else {
                $(this).draggable({disabled: true});
                $(this).removeAttr("tabindex");
                $(this).attr("aria-hidden","true");
                $(this).removeClass("tabindex");
                $(this).parent().addClass("inactive");
                $(this).removeClass("ui-draggable");
                $(this).find(".drag_span").removeClass("ui-draggable-handle");
                $(this).find(".dragHandle").removeClass("ui-draggable-handle");
            }

            /*if(!($(this).hasClass('correct-answer'))){
                incorrectArray.push($(this).html());
                incorrectOptions.push($(this).attr('data-answer'));
                $(this).parent().attr("dropped","false");
                $(this).remove();
            }
            else {
                $(this).draggable({disabled: true});
            }*/
            
        });
        var j = 0;
        var firstFrameDragElement = frameDragspot;
        DragSet = '';
        DragSet += '<ul class="frame headerFrame'+j+'">'; 
        var dataLbl;
        for (var i = 0; i < incorrectArray.length; i++) {

            dataLbl = (incorrectDataLabelBy[i]=="")?' aria-label="'+incorrectDataLabel[i]+'" ' : 'aria-labelledby="'+incorrectDataLabelBy[i]+'" ';

            DragSet += '<li class="dragspotWrapper" data-id="'+i+'"><div class="dragspot tabindex" aria-grabbed="false" data-answer="'+incorrectOptions[i]+'" '+dataLbl+'><div class="dragHandle"></div>'+incorrectArray[i]+'</div></li>';

            if((i+1) % frameDragspot == 0) {
                DragSet += '</ul>';
                j++;
                if(typeof incorrectArray[i+1] != 'undefined')
                    DragSet += '<ul class="frame headerFrame'+j+'">'; 
            }
        }
        DragSet += '</ul>';
               
        answerContainer.append(DragSet);
        if($('.frame').length == 1){
            DisableLeftArrow();
            DisableRightArrow();
        }
        aSlidesArray = new Array();
        $(".answer-container .frame").each(function() {
            $(this).css('display', 'none')

            aSlidesArray.push($(this))
            nCount++;
        });
        $(".answer-container .headerFrame0").show();
        fnCheckNextBack();
        makeDraggable();
        $(".audio").unbind().bind('click keydown touchstart', common.playAudio);
        $(".dragspotWrapper .dragspot").bind('keydown', handleDragByKey);
        $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        if(config.data.dnd1_activity_type == 'image'){
            $('.dragspot').css({width:"100px", "padding":'0px'});
        }
        $(".qdraglabel .zoomImg").unbind().bind('click keydown touchstart', imageModal);
    }
    function setQuizContainerHeight(){
        var offsetvar = 20;
        if($(window).innerWidth() < 500){
            offsetvar = 10;
        }
        setTimeout(function(){
            /*parentBottomOffset = window.parent.$('.bottom-container').offset().top;
            var quizHeight = parentBottomOffset - ( ($('#title').height() )+$('.drag_tray').height()+$('.qtitle').height()+$('.bottom-container').height()+offsetvar-1);
            quizHeight += $('.bottom-container').height()-10;
            $('#quiz-container').css({'height' :quizHeight+50+'px'});*/

            quizHeight = $('.bottom-container').offset().top - ($(".answer-container").offset().top + $(".answer-container").height());
            quizHeight -= 8;
            $('#quiz-container').css({'height' :quizHeight+'px'});
        }, 100);
        setTimeout(function(){
            /*parentBottomOffset = window.parent.$('.bottom-container').offset().top;
            var quizHeight = parentBottomOffset - ( ($('#title').height() )+$('.drag_tray').height()+$('.qtitle').height()+$('.bottom-container').height()+offsetvar);
            quizHeight += $('.bottom-container').height()-10;*/

            quizHeight = $('.bottom-container').offset().top - ($(".answer-container").offset().top + $(".answer-container").height());
            quizHeight -= 10;
            $('#quiz-container').css({'height' :quizHeight+'px'});
        }, 200);
    }
    app.setParameters = function() {
        var innerWidth = $(window).innerWidth();
        if(config.data.dnd1_activity_type == 'image'){
            if((innerWidth > 0) && (innerWidth <= 680)){
                frameDragspot = 1;
            }
            else if((innerWidth > 680) && (innerWidth <= 1000)){
                frameDragspot = 3;
            }
            else{
                frameDragspot = 5;
            }
        }
        else{
            if((innerWidth > 0) && (innerWidth <= 680)){
                frameDragspot = 1;
            }
            else if((innerWidth > 680) && (innerWidth <= 1000)){
                frameDragspot = 2;
            }
            else{
                frameDragspot = 3;
            }
        }
        if((innerWidth > 0) && (innerWidth <= 770))  {
            quizLayout = '1 Column';
        }
        else{
            quizLayout = '2 Column';
        }
    }
    function createFrames() {
        var j = 0;
        var k = 0;
        var firstFrameDragElement = frameDragspot;
        DragSet = '';
        for(var i=0; i<config.data.options.length;i++){
            OptionArray.push(i);
        }

        var ariaLabelContent;


        OptionArray = shuffle(OptionArray);   
        DragSet += '<ul class="frame headerFrame'+j+'">'; 
        for (var i = 0; i < config.data.options.length; i++) { 
                k = OptionArray[i];
                if (!isMobile())
                {
                    ariaLabelContent = 'aria-label="'+config.data.options[k]+'. Press the Enter or Spacebar Key to open drop location list. To move between the list items use the arrow keys."';
                }else{
                    ariaLabelContent = 'aria-labelledby="'+config.data.options[k]+'"';
                }

                DragSet += '<li class="dragspotWrapper" data-id="'+k+'"><div '+ariaLabelContent+' aria-grabbed="false" class="dragspot tabindex" data-answer="'+k+'"><div class="dragHandle"></div>';

                if(config.data.dnd1_activity_type != 'text' && config.data.option_image[k]){
                    DragSet += '<div class="qdraglabel"><img src="images/'+config.data.option_image[k]+'" class="tabindex" alt="'+config.data.option_image_alt_text[k]+'"><div aria-label="'+config.data.asset_alt_text[k]+' zoom image. '+clickTouchInst+' to open zoom image." class="zoomImg tabindex" data-src="images/'+config.data.option_image[k]+'" role="button"><img src="../../images/zoom.svg" alt="Zoom image" /></div></div>';
                }

                if(config.data.dnd1_activity_type == 'image'){
                    DragSet += '<div id="drag_txt_'+k+'" class="dragspot_txt">';
                } else {
                    DragSet += '<div id="drag_txt_'+k+'" class="dragspot_txt" data-baseText="'+config.data.options[k]+'">'+config.data.options[k];
                    if(config.data.option_audio[k] != '')
                        DragSet += '<div data-src="audio/'+config.data.option_audio[k]+'" class="audio audio_drag noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></div>';
                }

                DragSet += '</div><span class="zoomTextButton"><span class="zoomText tabindex" aria-label="'+clickTouchInst+' to read more contents"></span></span></div></li>';
                
                if((i+1) % frameDragspot == 0) {
                    DragSet += '</ul>';
                    j++;
                    if(typeof config.data.options[i+1] != 'undefined')
                        DragSet += '<ul class="frame headerFrame'+j+'">'; 
                }
            }
            DragSet += '</ul>';
    }
    app.updateFrames = function(){
        if (!answerContainer)
        {}else{
            var j = 0, i = 0;
            nSlideCounter = 0;   
            var currentFrame = $(".frame:visible").index();
            DragSet = '';
            var dragspots = $('.answer-container .dragspot').length;
            
            DragSet += '<ul class="frame headerFrame'+j+'">'; 
            var currentHTML;
            var currentDataAnswer;
            var ariaLabelContent;
            $('.answer-container .dragspot').each(function(){
                currentHTML = $(this).html();
                currentDataAnswer = $(this).attr('data-answer');

                if (!isMobile())
                {
                    ariaLabelContent = 'aria-label="'+$(this).text().trim()+'. Press the Enter or Spacebar Key to open drop location list. To move between the list items use the arrow keys."';
                }else{
                    ariaLabelContent = 'aria-labelledby="'+$(this).text().trim()+'"';
                }


                DragSet += '<li class="dragspotWrapper" data-id="'+i+'"><div aria-grabbed="false" class="dragspot tabindex" '+ariaLabelContent+' data-answer="'+currentDataAnswer+'">'+currentHTML+'</div></li>';
                if((i+1) % frameDragspot == 0) {
                    DragSet += '</ul>';
                    j++;
                    if(typeof $('.answer-container .dragspot')[i+1] != 'undefined'){
                        DragSet += '<ul class="frame headerFrame'+j+'">';
                    }
                }
                i++;
            });
            DragSet += '</ul>';
            answerContainer.html('');
            
            answerContainer.append(DragSet);
            aSlidesArray = new Array();
            $(".answer-container .frame").each(function() {
                $(this).css('display', 'none')
                aSlidesArray.push($(this))
                nCount++;
            });
            //$(".answer-container .frame:nth-child("+(currentFrame+1)+")").show();    
            $(".answer-container .frame:nth-child(1)").show();
            fnCheckNextBack();
            if($('.frame').length == 1){
                DisableLeftArrow();
                DisableRightArrow();
            }             
            makeDraggable();
            var dropspotWidth = $($('.dropspot')[0]).width();
            var dropspotHeight = $($('.dropspot')[0]).height();
            $('.dragspotWrapper').css({"width":dropspotWidth+'px', 'min-width':'200px'});
            $('.dragspotWrapper').css("height", '80px');

            $('.dragspot').css({"width":dropspotWidth+'px', 'min-width':'200px'});
            $('.dragspot').css("height", dropspotHeight+'px');
            $('.dragspotWrapper .dragspot').css("height", '75px');

            if(config.data.dnd1_activity_type == 'image'){
                $('.dragspot').css({'width':'100px', 'padding':'0px'});
                $('.dragspotWrapper').css({'margin':'10px 26px'});
            }
            $(".audio").unbind().bind('click keydown touchstart', common.playAudio);

            $('.answer-container .frame').each(function(){
                if($(this).is(':empty')){
                    $(this).remove()
                }
            });
            if($('.answer-container .frame').length == 0 || $('.answer-container .frame').length == 1){
               
            }
            addTabIndex();
            $(".qdraglabel .zoomImg").unbind().bind('click keydown touchstart', imageModal);
            
            var avatar_width = $('#maincontainer').width() - $('.qtitle_image').width()-25;
            $('.avatar_text').css('width',avatar_width);
            
            var innerWidth = $(window).innerWidth();

            if(config.data.dnd1_activity_type == 'image'){
                $('.draglabel').css('margin','0px 0px 16px 27px');

                if((innerWidth > 0) && (innerWidth <= 600)){
                    $('.draglabel').css({'width':'90%' });
                    $('.draglabel').css('margin-left','10%');
                }
                else if((innerWidth > 600) && (innerWidth <= 1000)){
                    $('.draglabel').css({'width':'42%' });
                }
                else{
                    $('.draglabel').css({'width':'30%' });
                }
            }

            $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
            setQuizContainerHeight();
            displayReadMoreIcon();
        }
    }
    function shuffle(array) {
        var currentIndex = array.length,
            temporaryValue, randomIndex;
        while (0 !== currentIndex) {
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex -= 1;
            temporaryValue = array[currentIndex];
            array[currentIndex] = array[randomIndex];
            array[randomIndex] = temporaryValue;
        }
        return array;
    }

    function handleScrollPaneTouchMove(e)
    {
        tempDragKey = null;
    }

    var inTap = false;
    function handleTap(e)
    {
        //return;
        if (isMobile() && e.type == "click")
        {

            return;
        }
        if ($(this).parent().hasClass("ui-draggable-disabled"))
        {
             return;
        }

        if (!optMoved)
        {
            if (tempDragKey == null){
                tempDragKey = $(this).parent();

                if (!tempDragKey.hasClass("dragspot")){
                    tempDragKey = $(this).parent().find(".dragspot");
                }
                if (!$(this).parent().parent().parent().parent().hasClass("answer-container"))
                   inTap = true;
                //e.stopPropagation();
            }
        }
    }
    var itemInDrop = false;


    
    function handleDropByClick(e){
        //return;
        if (isMobile() && e.type == "click")
        {

            return;
        }

        if (!optMoved)
        {
            if (!inTap)
            {
                if(tempDragKey){
                    var thisDropID = $(this).attr('id');
                    placeOptionToDropLocation(tempDragKey, $("#"+thisDropID));



                }
                tempDragKey = null;
            }
            inTap = false;
        }
    }




    function handleRemoveDragByKey(e){
        if(e.keyCode !== 13 && e.keyCode !== 32){
            return false;
        }
        var newDragspotWrapper = $('<li>', {class:'dragspotWrapper'}); 
        newDragspotWrapper.attr('data-id',$(this).attr('data-answer'));
        $(this).parent().attr("dropped","false");
        $(this).removeClass('correct incorrect-answer');
        newDragspotWrapper.append($(this));
        if($(".answer-container .frame").length > 0){
            $(".answer-container .frame:nth-child(1)").prepend(newDragspotWrapper); 
            if($(".dropspot .dragspot").length < 1){
                resetButton.addClass("disabled").attr("disabled","disabled");
            }  
        }
        else{
            if($(".answer-container .frame").length < 1){
                var newFrame = $('<ol>', {class:'frame headerFrame0'});
                newFrame.append(newDragspotWrapper);
                $(".answer-container").append(newFrame);
                submitButton.addClass('disabled');
                submitButton.attr('disabled','disabled');
            }                  
        }          
        app.updateFrames();
        addTabIndex();
        $(".dragspotWrapper .dragspot").bind('keydown', handleDragByKey);
        $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        e.preventDefault();
        e.stopPropagation();
    }

    function handleDragByKey(e){
        if (e.type==="keydown" && (e.keyCode !== 13 && e.keyCode !== 32)) {
        }else{
            e.preventDefault();
            e.stopPropagation();
            e.stopImmediatePropagation();
            DragID = $(this).attr("data-id");
            var isHome = false;
            var currentDrag = $(this);
            var DropList = "";
            DropListContainer = "";

            DropListContainer = $('<ul id="popup" role="menu"></ul>');
            $(".dropspot").each(function(index) {
                if (!$(this).hasClass('inactive')) {
                    if ($(this).children().hasClass('dragspot')) {
                        if ($(currentDrag).parent().attr("data-id") === $(this).attr("data-id")) {
                            isHome = true;
                        } else {
                            $(this).attr("aria-dropeffect", "move");
                            DropList += '<li tabIndex="-1" id="' + DropListArray[index] + '" aria-label="' + DropListAriaLabel[index] + '" role="menuitem" class="dropList focus" data-id="' + $(this).attr("data-id") + '">' + DropListArray[index] + '</li>';
                        }
                    } else {
                        $(this).attr("aria-dropeffect", "move");
                        DropList += '<li tabIndex="-1" id="' + DropListArray[index] + '" aria-label="' + DropListAriaLabel[index] + '" role="menuitem" class="dropList focus" data-id="' + $(this).attr("data-id") + '">' + DropListArray[index] + '</li>';
                    }
                }
            });
            
            if (isHome) {
                $("#dragContainer").attr("aria-dropeffect", "move");
                DropList += '<li tabIndex="-1" id="' + DropListArray[DropListArray.length - 1] + '" aria-label="' + DropListAriaLabel[DropListAriaLabel.length - 1] + '" role="menuitem" class="dropList focus">' + DropListArray[DropListArray.length - 1] + '</li>';
                isHome = false;
            }

            DropListContainer.append(DropList);
            $(this).parent().append(DropListContainer);

            if ($(this).parent().parent().attr("data-id") === "dragContainer") {
                $('#Home').remove();
            }
            $(".dropList").bind('keydown', handleDropByList);
            $(".dropList").first().focus();
        }
    }


    function handleDropByList(e) {
        var charCode = (e.which) ? e.which : e.keyCode;
        if ((e.type === 'keydown') && (charCode !== 13) && (charCode !== 32) && (charCode !== 9) && (charCode !== 37) && (charCode !== 38) && (charCode !== 39) && (charCode !== 40) && (charCode !== 27)) {
            
        }else{
            e.stopPropagation();
            e.preventDefault();
            switch (charCode) {
                case 38: // Down arrow
                    $(e.currentTarget).prev().focus();
                    break;
                case 40: // Up arrow
                    $(e.currentTarget).next().focus();
                    break;
                case 27: // Escape
                case 9: //Tab
                    $(this).parent().parent().focus();
                    $('#popup').remove();
                    $(".dropspot, #dragContainer").removeAttr("aria-dropeffect");
                    $(".dragbox").attr("aria-grabbed", "false");
                    break;
                case 13: // Enter
                case 32: // Space
                    tempDragKey = $(this).parent().parent().find(".dragspot");
                    tempDragKeyID = $(this).parent().parent().parent().attr("id");

                    if ($('#' + tempDragKeyID).hasClass("dropspot")) {
                        $('#' + tempDragKeyID).attr("dropped", 'false');

                    }
                    var listarr = "Home"
                    var match = '';
                    for (j = 0; j < DropListArray.length; j++) {
                        if ($(this).attr("id") === DropListArray[j]) {
                            listarr = DropListArray[j];
                            match = j;
                        }
                    }
                    if (listarr != "Home") {
                        placeOptionToDropLocation(tempDragKey, $($('.dropspot')[match]));
                    } else {
                        if (tempDragKey.parent().hasClass("dropspot")){
                            tempDragKey.parent().attr("dropped", "false");
                            tempDragKey.removeClass('incorrect-answer');
                            tempDragKey.parent().addClass('dotted-frame');
                        }

                        var newDragspotWrapper = $('<li>', {class: 'dragspotWrapper'});
                        newDragspotWrapper.attr('data-id', tempDragKey.attr('data-answer'));
                        $($('.dropspot')[match]).attr("dropped", "false");
                        tempDragKey.removeClass('correct incorrect-answer');
                        newDragspotWrapper.append(tempDragKey);

                        newDragspotWrapper.css({"width": "215px", "height": "30px"});


                        if ($(".answer-container .frame").length > 0) {
                            $(".answer-container .frame:nth-child(1)").prepend(newDragspotWrapper);
                        } else {
                            if ($(".answer-container .frame").length < 1) {
                                var newFrame = $('<ul>', {class: 'frame headerFrame0'});
                                newFrame.append(newDragspotWrapper);
                                $(".answer-container").append(newFrame);
                                submitButton.addClass('disabled');
                                submitButton.attr('disabled', 'disabled');
                            }
                        }

                        app.updateFrames();
                    }

                    $(".dropspot, #dragContainer").removeAttr("aria-dropeffect");

                    $(".dragbox").attr("aria-grabbed", "false");
                    //$(".dragbase .dragbox:first").focus();

                    setTimeout(function(){
                        $(".drag_tray .dragspot:first").focus();
                    },100);

                    $(".dragspotWrapper .dragspot").unbind('keydown').bind('keydown',handleDragByKey);

                    $('#popup').remove();
                    break;
            }
        }
    }

    function placeOptionToDropLocation(optionInDrag, dropLocation) {
        if(dropLocation.children().hasClass("ui-draggable-disabled")){
            return;
        }

        if (optionInDrag.parent().hasClass("dropspot")){
            optionInDrag.parent().attr("dropped", "false");
            optionInDrag.removeClass('incorrect-answer');
            optionInDrag.parent().addClass('dotted-frame');
            //$('.dropspot').removeAttr("tabindex");
        }

        optionInDrag.attr("aria-grabbed", 'false');
        $('.dropspot').attr("aria-dropeffect", 'none');

        if (dropLocation.attr("dropped") != 'true') {
            dropLocation.attr("dropped", 'true');
        }else{
            var newDragspotWrapper = $('<li>', {class: 'dragspotWrapper'});
            newDragspotWrapper.attr('data-id', dropLocation.children().attr('data-answer'));
            //$(this).attr("dropped", "false");
            dropLocation.children().removeClass('correct incorrect-answer');
            newDragspotWrapper.append(dropLocation.children());



            if ($(".answer-container .frame").length > 0) {
                $(".answer-container .frame:nth-child(1)").prepend(newDragspotWrapper);
            } else {
                if ($(".answer-container .frame").length < 1) {
                    var newFrame = $('<ul>', {class: 'frame headerFrame0'});
                    newFrame.append(newDragspotWrapper);
                    $(".answer-container").append(newFrame);
                    submitButton.addClass('disabled');
                    submitButton.attr('disabled', 'disabled');
                }
            }
            
        }


        dropLocation.removeClass('dotted-frame');
        optionInDrag.addClass('correct');
        optionInDrag.position({of: dropLocation});
        optionInDrag.appendTo(dropLocation);
        optionInDrag.css({'top': '0px', 'left': '0px', 'position': 'absolute'});
        var correct_answer = dropLocation.attr('data-answer');
        var dropped_answer = dropLocation.find('.dragspot').attr('data-answer');
        if (correct_answer == dropped_answer) {
            dropLocation.find('.dragspot').addClass('correct-answer');
        }
        else {
            dropLocation.find('.dragspot').addClass('incorrect-answer');
            optionInDrag.removeClass('incorrect-answer');
            optionInDrag.parent().addClass('dotted-frame');
            $('.dropspot').removeAttr("tabindex");
            addTabIndex();
        }

        autoUpdatedDragBoxForTab();
        resetButton.removeClass('disabled');
        resetButton.removeAttr('disabled').attr("tabindex","0");
        var all_dropped = true;
        $('.dropspot').each(function () {
            if ($(this).attr("dropped") != 'true')
                all_dropped = false;
        });
        all_correct = true;
        $(".dropspot").each(function () {
            var correct_answer = dropLocation.attr('data-answer');
            var dropped_answer = dropLocation.find('.draggable').attr('data-answer');
            if (correct_answer != dropped_answer) {
                all_correct = false;
            }
        });
        if (all_dropped) {
            submitButton.removeClass('disabled');
            submitButton.removeAttr('disabled').attr("tabindex","0");;
            if(!isMobile()){
                setTimeout(function(){
                    submitButton.focus();
                },100);
            }
            if (all_correct) {
                //All answers are correct.
            }
        }
        if (!$('.answer-container .dragSpotWrapper .dragSpot').length) {
            DisableLeftArrow();
            DisableRightArrow();
        }
        
        $('.dropspot').each(function() {
            dropLocation.removeAttr('tabindex');
        });


        app.updateFrames();


        $(".dragspotWrapper .dragspot").unbind('keydown').bind('keydown', handleDragByKey);
        $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        //addTabIndex();
        if ($('.answer-container .dragspot').length) {
            if(!isMobile()){
                $('.answer-container .dragspot')[0].focus();
            }
        }else{
            setTimeout(function(){
                submitButton.focus();
            },100);
        }
    }


    function handleDropByKey(e){
       if(e.keyCode !== 13 && e.keyCode !== 32){
            
        }else{
            tempDragKey.attr("aria-grabbed", 'false');
            $('.dropspot').attr("aria-dropeffect", 'none');
            if($(this).attr("dropped") != 'true') {
                $(this).attr("dropped", 'true');
                $(this).removeClass('dotted-frame');
                tempDragKey.addClass( 'correct' );
                tempDragKey.position( { of: $(this)} );
                tempDragKey.appendTo($(this));
                tempDragKey.css( {'top':'0px','left':'0px','position':'absolute'} );
                var correct_answer = $(this).attr('data-answer');
                var dropped_answer = $(this).find('.dragspot').attr('data-answer');
                if(correct_answer == dropped_answer) {
                    $(this).find('.dragspot').addClass('correct-answer');
                }
                else {
                    $(this).find('.dragspot').addClass('incorrect-answer');
                    tempDragKey.removeClass('incorrect-answer'); 
                    tempDragKey.parent().addClass('dotted-frame');
                    $('.dropspot').removeAttr("tabindex");
                    addTabIndex();
                }
                autoUpdatedDragBoxForTab();
                resetButton.removeClass('disabled');
                resetButton.removeAttr('disabled').attr("tabindex","0");;
                var all_dropped = true;
                $('.dropspot').each(function(){
                    if($(this).attr("dropped") != 'true')
                        all_dropped = false;
                });
                if(all_dropped) {
                    submitButton.removeClass('disabled');
                    submitButton.removeAttr('disabled').attr("tabindex","0");;
                    if(!isMobile())
                        submitButton.focus();
                }
                if(!$('.answer-container .dragSpotWrapper .dragSpot').length){
                    DisableLeftArrow();
                    DisableRightArrow();
                }
            }
            $('.dropspot').each(function() {
                $(this).removeAttr('tabindex');
            });
            addTabIndex();
            if($('.answer-container .dragspot').length){
                if(!isMobile())
                    $('.answer-container .dragspot')[0].focus();
            }
            $('.dropspot .dragspot').unbind('keydown').bind('keydown', handleRemoveDragByKey);
            $('.dropspot .ui-draggable-disabled').unbind('keydown');
            
            if($('.frame').length == 1){
                DisableLeftArrow();
                DisableRightArrow();
            }
        }
    }
    
    function autoUpdatedDragBoxForTab() {
        lastFrame = $('.answer-container > .frame').last();
        lastFrameDragSpot = $(lastFrame).children().first();             
        currentFrame = $(tempkey).parent();
        $(tempkey).remove();
        if (!(($(lastFrame).attr('class')) == ($(currentFrame).attr('class')))) {
            $(currentFrame).append(lastFrameDragSpot);
        }
        if($(lastFrame).is(':empty')) {
            nCount = 0;
            $(lastFrame).remove();
            aSlidesArray = new Array()
            $(".answer-container .frame").each(function() {
                aSlidesArray.push($(this))
                nCount++;
            });
        }
        if ($(currentFrame).is(':empty')) {
            backSlide();
            $('.rightArrow').addClass('rightArrowDisable');
        }
        lastFrame = $('.answer-container > .frame').last();
        if (($(lastFrame).attr('class')) == ($(currentFrame).attr('class'))) {
            $('.rightArrow').addClass('rightArrowDisable');
        }
        if($('.answer-container .dragspot').length){
            if(!isMobile())
                $('.answer-container .dragspot')[0].focus();
        }
        else{
            addTabIndex();
        }
        displayReadMoreIcon();
    }
    /*Anser container Arrow Next Previous */
    function EnableLeftArrow(){
        $(".leftArrow").removeClass("leftArrowDisable disabled").addClass("leftArrowEnable").css({"pointer-events":"auto", "cursor":"pointer"});
        $(".leftArrow").attr('tabindex',0);
        $(".leftArrow").removeAttr('aria-disabled');
    }
    function DisableLeftArrow(){
        $(".leftArrow").removeClass("leftArrowEnable").addClass("leftArrowDisable disabled").css({"pointer-events":"none", "cursor":"default"});
        $(".leftArrow").attr('tabindex',-1);
        $(".leftArrow").attr('aria-disabled','true');

        $(this).parent().find('.frame:visible .dragSpot:first').focus()
    }
     function EnableRightArrow(){
        $(".rightArrow").removeClass("rightArrowDisable disabled").addClass("rightArrowEnable").css({"pointer-events":"auto", "cursor":"pointer"});
        $(".rightArrow").attr('tabindex',0);  
        $(".rightArrow").removeAttr('aria-disabled');  
    }
    function DisableRightArrow(){
        $(".rightArrow").removeClass("rightArrowEnable").addClass("rightArrowDisable disabled").css({"pointer-events":"none", "cursor":"default"});
        $(".rightArrow").attr('tabindex',-1);
        $(".rightArrow").attr('aria-disabled', 'true');
    }
    function autoUpdatedDragBox() {
        lastFrame = $('.answer-container > .frame').last();
        lastFrameDragSpot = $(lastFrame).children().first();             
        currentFrame = $(tempParent).parent();
        $(tempParent).remove();

        if(!(($(lastFrame).attr('class')) == ($(currentFrame).attr('class')))) {
            $(currentFrame).append(lastFrameDragSpot);
        }
        if($(lastFrame).is(':empty')) {
           nCount = 0;
           $(lastFrame).remove();
           aSlidesArray = new Array()
           $(".answer-container .frame").each(function() {
               aSlidesArray.push($(this))
               nCount++;
           });
        }
        if($(currentFrame).is(':empty')) {
            backSlide();
            $('.rightArrow').addClass('rightArrowDisable');
        }
        lastFrame = $('.answer-container > .frame').last();
        if (($(lastFrame).attr('class')) == ($(currentFrame).attr('class'))) {
            $('.rightArrow').addClass('rightArrowDisable');
        }
        var dropspotWidth = $($('.dropspot')[0]).width();
        var dropspotHeight = $($('.dropspot')[0]).height();
        $('.dragspotWrapper').css("width", dropspotWidth+'px');
        //$('.dragspotWrapper').css("height", dropspotHeight+'px');
        $('.dragspotWrapper').css("height", '80px');
        $('.draglabel .dragspot').css("width", dropspotWidth+'px');
        $('.draglabel .dragspot').css("height", dropspotHeight+'px');

        if(config.data.dnd1_activity_type == 'image'){
            $('.dragspot').css({width:"100px", "padding":'0px'});
        }
        displayReadMoreIcon();
    }
    function fnCheckNextBack() {
        DisableLeftArrow();
        DisableRightArrow();
        if (nSlideCounter == 0) {
            if($(".frame").length > 1){
                EnableRightArrow();
            }
        }else if (nSlideCounter == aSlidesArray.length-1) {
            EnableLeftArrow();
        }else{
            EnableLeftArrow();
            EnableRightArrow();
        }
        displayReadMoreIcon();

    }
    function fnNext(ev){
       if(ev.type=="keydown" && ev.keyCode !=13 && ev.keyCode !== 32){    
             
        }else{
            if(nSlideCounter<(nCount-1)){
                nSlideCounter++;
                EnableRightArrow();
                $(".frame").hide();
                $(".headerFrame"+nSlideCounter).show();
                addTabIndex();
                if(!isMobile()){
                    $(this).parent().find('.frame:visible .dragSpot:first').focus();
                }
            }else{
                DisableRightArrow();   
            }
            setTimeout(function(){
                fnCheckNextBack();
            },100);
        }
    }
    function fnBack(ev){
        if(ev.type=="keydown" && ev.keyCode !=13 && ev.keyCode !== 32){    
        }else{
            backSlide();
            addTabIndex()
            if(!isMobile()){
                $(this).parent().find('.frame:visible .dragSpot:first').focus()
            }
        }
      }
    function backSlide(){
        if(nSlideCounter>0){
             nSlideCounter--;
             $(".frame").hide();
             $(".headerFrame"+nSlideCounter).show();
             
        }else{
            DisableLeftArrow();
        }
       setTimeout(function(){
            fnCheckNextBack();
        },100);
   }
   function detectDevice(){
        var screenWidth = $(window).width();
   }
})(Widget = Widget || {});
var Widget;
$(document).ready(function(){
});
$(window).resize(function(){
    Widget.setParameters();
    Widget.updateFrames();
});
var parentBottomOffset;
var isMobile;