/*DND-1 Preloader */
var imagePreCount = 0;
var audioPreCount = 0;
var imgPreloadArray = new Array(
  "images/audio_button.svg",
  "images/page_number_bg_white.svg",
  "images/back_button.svg",
  "images/incorrect_icon.svg",
  "images/play_again_pencil_bg.svg",
  "images/popup_close_button.svg",
  "images/next_button.svg",
  "images/correct_icon.svg",
  "images/next_pencil_bg.svg",
  "images/zoom_icon.svg",
  "images/page_number_bg_black.svg",
);

/*--Audio--*/
var audioPreloadArray = [];
$(document).ready(function () {
  generatePreloader();
  getAudios(config.data);
  var firstAudio = audioPreloadArray[0];
  // audioPreloadArray.push(firstAudio);
  // console.log(audioPreloadArray.length)

  preloadAudios();

  getImages();
  preloadImages();
});

function generatePreloader() {
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle1 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle2 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle3 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle4 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle5 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle6 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle7 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle8 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle9 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle10 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle11 preloader-child"></div>');
  $(".preloaderDiv .preloaderIcon").append('<div class="preloader-circle12 preloader-child"></div>');
}

function preloadImages() {
  imagePreCount = 0;
  for (var pId = 0; pId < imgPreloadArray.length; pId++) {
    var img = new Image();
    img.onload = imagePreloaded;
    img.src = imgPreloadArray[pId];
  }
}
function imagePreloaded() {
  imagePreCount++;
  if (imagePreCount == imgPreloadArray.length) {
    Widget.preloadingDataComplete();
  }
}
function preloadAudios() {
  var audioPath;
  config.data.soundArr = [];
  config.data.soundKeyArr = [];
  for (var i = 0; i < audioPreloadArray.length; i++) {
    audioPath = audioPreloadArray[i];
    config.data.soundKeyArr[i] = audioPath;
    config.data.soundArr[i] = (new Howl({
      src: [audioPath],
      html5: true,
      volume: 1,
    }));

    config.data.soundArr[i].once('load', function () {
      audioPreCount++;
      console.log('loaded..')
    });

  }
  //config.data.soundArr[1].play();
  //console.log('audioPreloaded', audioPreloadArray)
}

function getImages() {
  var tempPath = 'images/';
  var avatar_act = tempPath + config.data.avatar_active;
  var avatar_inact = tempPath + config.data.avatar_in_active;
  // if (avatar_act != tempPath) {
  //   imgPreloadArray.push(avatar_act);
  // }
  // if (avatar_inact != tempPath) {
  //   imgPreloadArray.push(avatar_inact);
  // }
  for (var i = 0; i < config.data.assets.length; i++) {
    var assetImages = tempPath + config.data.assets[i];
    if (assetImages != tempPath) {
      imgPreloadArray.push(assetImages)
    }
  }
}