/* DND1 widget File */
(function (app) {
    var aSlidesArray = new Array();
    var nCount = 0;
    var pageNo = 1;
    var totalPage = config.data.question_list.length ? Math.ceil(config.data.question_list.length / parseInt(config.data.questionPerPage)) : 1;
    var title;
    var questionWrapper;
    var answerContainer;
    var title;
    var comDiv;
    var statusContainer;
    var submitButton;
    var resetButton;
    var maincontainer;
    var DragSet = "";
    var tempParent;
    var totalAttempts = 0;
    var activityTotalAttempts = 3;
    var all_correct;
    var frameDragspot = 2;
    var innerWidth = $(window).innerWidth();
    var innerHeight = $(window).innerHeight();
    var userAnswers = [];
    var tempDragKey;
    var tempkey;
    var assetsLoaded = false;
    var quizLayout = '2 Column';
    var currentObjFocus;
    var lang;
    var optMoved = false;
    var DropListContainer;
    var DropListArray = ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "Home"];
    var DropListAriaLabel = [
        "Sequence 1",
        "Sequence 2",
        "Sequence 3",
        "Sequence 4",
        "Sequence 5",
        "Sequence 6",
        "Sequence 7",
        "Sequence 8",
        "Sequence 9",
        "Sequence 10",
        "Sequence 11",
        "Sequence 12",
        "Sequence 13",
        "Sequence 14",
        "Sequence 15",
        "Home"
    ];

    var clickTouchInst;


    /// ===== cloze =======

    var titleAudio;
    var titleAudioImg;
    var questionNo = 0;
    var playActivity, playButtonImg, playButton, playButtonMsg, activityContainer, titleContainer;
    var correctAnsArr = new Array(config.data.question_list.length).fill(false);


    app.init = function () {
        window.parent.document.title = config.data.title;
        if (!assetsLoaded) {
            generatePreloader();
            preloadImages();
            return false;
        }

        clickTouchInst = isMobile() ? "" : "";


        var myLanguage = config.data.lang;
        if (typeof myLanguage == 'undefined') {
            myLanguage = 'English';
        }
        lang = LangConst.languages[myLanguage];

        if (config.data.total_attempts) {
            activityTotalAttempts = Number(config.data.total_attempts)
        }

        totalAttempts = 0;
        nSlideCounter = 0;
        aSlidesArray = [];
        OptionArray = [];
        maincontainer = $("#data-elements");
        maincontainer.empty();
        Widget.setParameters();
        createObjects();
        var dropspotWidth = $($('.dropspot')[0]).width();
        var dropspotHeight = $($('.dropspot')[0]).height();
        $('.dragspotWrapper').css("width", dropspotWidth + 'px');
        //$('.dragspotWrapper').css("height", dropspotHeight+'px');
        $('.dragspotWrapper').css("height", '82px');
        $('.dragspot').css("width", dropspotWidth + 'px');
        $('.dragspotWrapper .dragspot').css("height", '82px');

        if (config.data.dnd1_activity_type == 'image') {
            $('.dragspot').css({ width: "100px", "padding": '0px', "height": '100px' });
            $('.dropspot').css({ width: "100px", "padding": '0px', "height": '100px' });
            $('.dragspot_txt').css({ "padding": '0px' });
            $('.qlabel').css({ "width": '100px', "height": '100px' });
        }
        if (config.data.dnd1_activity_type == 'both') {
            $('.dragspot').css({ "padding": '10px' });
            $('.draglabel').css({ "height": '100px' });
            $('.qlabel').css({ "width": '100px', "height": '100px' });
            $('.qdraglabel img').css({ "width": '60px', "height": '60px' });
            $('.qdraglabel').css({ "width": '62px', "height": '62px' });
        }
        //Widget.setParameters();
        Widget.updateFrames();
        addEvents();
        addTabIndex();
        displayReadMoreIcon();
        detectDevice();
        /*var quizHeight = $(window).innerHeight() - ($('.bottom-container').height()+$('#title').height()+$('.drag_tray').height()+$('.qtitle img').height());
        setTimeout(function(){
            parentBottomOffset = window.parent.$('.bottom-container').offset().top;
            var quizHeight = parentBottomOffset - ($('#title').height()+$('.drag_tray').height()+$('.qtitle img').height()+60);
            $('#quiz-container').css({'height' :quizHeight+'px'});
        }, 200);*/
        if (!isMobile())
            $('.titletext').focus();
    }
    app.preloadingDataComplete = function () {
        assetsLoaded = true;
        Widget.init();
    }
    function createObjects() {
        document.title = config.data.title;
        titleContainer = $('<div>', { class: 'title_container dnone'});
        title = $('<div>', { id: 'title', class: 'dnone' });
        titleHeading = $('<h1>', { class: 'titletext', 'tabindex': '-1'});
        titleHeading.append(config.data.title);

        titleAudio = $('<div>', { 'role':'button', 'class': 'audioContainer audio', 'data-src': 'audio/' + config.data.title_audio, 'aria-hidden': 'true' });
        titleAudioImg = $('<img>', { 'src': 'images/audio_button.svg', 'alt':'' });
        titleAudio.append(titleAudioImg);
        title.append(titleHeading);
        title.append(titleAudio);
        activityContainer = $('<div>', { class: 'activity_container dnone', "aria-describedby":"activity_tip" });

        var quesTip = $("<div>", { class: "tipContainer", tabindex: "0", role: "button",  'aria-expanded':"false", 'aria-controls':"activity_tip"});
        var quesTipText = $("<div>", { class: "tipText" }).text("Activity Tip");
        quesTipDownArow = $('<img src="images/down_arrow.svg" alt="" />');
        quesTip.append(titleAudio.clone().addClass("audio-btn"));
        quesTip.append(quesTipText);
        quesTip.append(quesTipDownArow);


        playActivity = $('<div>', { class: "play-container " });
        playButtonImg = $('<div>', { class: "play-button play-img", tabindex: "0", role: "button" })
        playButtonText = $('<p>', { class: "play-text" }).text("Play");
        playButton = $('<div>', { class: "play-button-main play" })
        playButtonImg.append(playButtonText);
        playButtonImg.append(titleAudio.clone().addClass("audio-btn").attr('data-src', 'audio/' + config.data.play_audio));
        playButton.append(playButtonImg);
        playButton.find(".play-button").addClass("large");
        playActivity.append(title.clone().removeClass('dnone').addClass('play-heading').removeAttr('id'));
        playActivity.append(playButton);

        questionWrapper = $('<div>', { id: 'questionWrapper', class: " dnone" });
        if (config.data.question_list.length > 0) {
            createQues();
        }

        // if(config.data.title_audio != ''){
        //     titleAudio = $("<a href='javascript:void(0)' data-src='audio/"+config.data.title_audio+"' class='audio audio_title' aria-hidden='true' tabindex='-1'><img src='../../images/audio_white.svg' alt='' /></a>");
        //     title.append(titleAudio);
        // }

        // helpHint = $('<span>', {class:'helpHint', id: 'helpHintText'});
        // helpHintHref = $('<div>', {class:'helpHintLink tabindex', 'aria-label':'About this activity. '+clickTouchInst+' to open About this Activity pop up.', 'role': 'button'});
        // helpHintImage = $('<img>', {src:'../../images/info.svg', 'title': lang.aboutThisActivity,'alt': lang.aboutThisActivity});
        // helpHintHref.append(helpHintImage);
        // helpHint.append(helpHintHref);

        // console.log(config.data.hint_type,"llllll")
        // if(config.data.hint_type.length){
        //     title.append(helpHint);
        // }


        // var clearDiv = $('<div>', {'style':'clear:both;'});

        bottomContainer = $('<div>', { class: 'bottom-container', id: 'page-bottom-container'});
        buttonContainer = $('<div>', { class: 'page-container', role: "navigation", "aria-label": "pagination" });
        pageStatus = $('<ul class="page-status"></ul>', { class: '' });
        for (var i = 0; i < totalPage; i++) {
            var className = "";
            if (i == 0) {
                className = "active";
            }
            var pageNo = $('<li class="page-no ' + className + '" data-page ="' + (i + 1) + '" aria-label="page' + (i + 1) + '"  aria-label="page' + (i + 1) + '" tabindex="0">' + (i + 1) + ' </li>');
            if (i === 0) {
                pageNo = $('<li aria-current="page" class="page-no ' + className + '" data-page ="' + (i + 1) + '" aria-label="page' + (i + 1) + '"  aria-label="page' + (i + 1) + '" tabindex="0">' + (i + 1) + ' </li>');
            }
            pageStatus.append(pageNo);
        }
        prevIcon = $('<div>', { class: 'nav-button  prev dnone prevPage', role: "button", "aria-label": "Previous" });
        nextIcon = $('<div>', { class: 'nav-button nextPage2 nextPage ', role: "button", "aria-label": "Next" });
        buttonContainer.append(prevIcon);
        buttonContainer.append(pageStatus);
        buttonContainer.append(nextIcon);
        var activeDivLeft = $('<div>', { class: "tip_left" });
        var activeDivRight = $('<div>', { class: "tip_right" });
        activeDivLeft.append('<p class="tip_text">' + config.data.activity_tip + '</p>');
        activeDivRight.append('<div class="audioContainer audio-btn audio " "aria-hidden"="true" data-src="audio/' + config.data.activity_tip_audio + '"><img alt="" src="images/audio_button.svg"></div>');
        activityContainer.append(activeDivLeft);
        activityContainer.append(activeDivRight);

        statusContainer = $('<div id="status-container" class="status-container dnone"><div class="status-back" tabindex="0" role="button"><p class="status-text">try again</p><div class="audioContainer audio-btn audio" aria-hidden="true" data-src="audio/"><img src="images/audio_button.svg" alt=""></div></div></div>');

        titleContainer.append(title);
        titleContainer.append(quesTip);
        maincontainer.append(titleContainer);
        maincontainer.append(activityContainer);
        maincontainer.append(playActivity);
        maincontainer.append(questionWrapper);
        maincontainer.append(statusContainer);

        bottomContainer.append(buttonContainer).addClass("dnone");
        maincontainer.append(bottomContainer);

        fnCheckNextBack();
    }
    function createQues() {
        questionWrapper.empty();
        qtitle = $('<div>', { class: 'qtitle', tabindex: -1  });
        var question_txt = config.data.question_list[questionNo].question;
        quizContainer = $('<div>', { id: 'quiz-container', class: 'quiz-container', tabindex: -1 });
        var dropspot;
        var text = 'Question No ' + (questionNo + 1) + " ";
        qtitletext = '<p class="ques_text">' + question_txt + '</p>';

        qtitle.append(qtitletext);
        var quesAudio = $('<div class="audioContainer audio-btn audio " "aria-hidden"="true" data-src="audio/' + (config.data.question_list[questionNo].audio) + '"><img src="images/audio_button.svg" "aria-hidden"="true" alt ></div>');
        if(question_txt != "") {
            qtitle.append(quesAudio);
        }
        $(qtitle).find("#drop_item_" + questionNo).attr("aria-label", text);
        quizContainer.append(qtitle);

        drag_Tray = $('<div>', { class: 'drag_tray' });
        comDiv = $("<div>", { class: "comp_div",'aria-live':'assertive', tabindex: -1  });
        // statusContainer = $('<div id="status-container" class="status-container dnone"><div class="status-back" tabindex="0" role="button"><p class="status-text">try again</p><div class="audioContainer audio-btn audio" aria-hidden="true" data-src="audio/"><img src="images/audio_button.svg" alt=""></div></div></div>');
        // DragInstructions = '<p class="screenhide dragstart" aria-label="Select a name and drop it on the input field of its related category by pressing Enter key."> &nbsp;</p>';
        drag_Tray.append(comDiv);

        answerContainer = $('<div>', { class: 'answer-container' });
        $(drag_Tray).append(answerContainer);
        
        //Add frames to dragspot         
        createFrames();
        $(questionWrapper).append(quizContainer);
        answerContainer.append(DragSet);
        $(questionWrapper).append(drag_Tray);
        // $(questionWrapper).append(statusContainer);

        // setTimeout(() => {
        //     $(qtitletext).focus();
        // }, 1000);
        
    }
    function zoomTextModal(e) {
        openHint(e, $(this), 'zoomText');
        e.preventDefault();
        e.stopPropagation();
        e.stopImmediatePropagation();
    }
    function addEvents() {
        $(".play-button-main .play-img").unbind().bind('click keydown ', function (e) {
            if (e.keyCode === 13 || e.keyCode === 32 || e.type === "click") {
                playActivity.addClass("dnone");
                questionWrapper.removeClass("dnone");
                bottomContainer.removeClass("dnone");
                titleContainer.removeClass("dnone");
                $('.tipContainer').focus();
                $('#title').removeClass("dnone");
                if ($(".quiz-container").innerHeight() > 80) {
                    $(".quiz-container").addClass("break_line")
                } else {
                    $(".quiz-container").removeClass("break_line")
                }
            setHeight();
            }
        })
        // $(".play-button-again .play-img").unbind().bind('click keydown ', function (e) {
        //     if (e.keyCode === 13 || e.keyCode === 32 || e.type === "click") {
        //         playAgainButton.addClass("dnone");
        //         playButton.addClass("dnone");
        //         playButtonMsg.removeClass("dnone");
        //         questionNo = 0;
        //         pageNo = 1;
        //         createQues();
        //         fnCheckNextBack();
        //         correctAnsArr = [];
        //     }
        // })
        $(".tipContainer").unbind().bind('keydown click', function (e) {
            if (e.type == "click" || e.keyCode == 13 || e.keyCode == 32) {
                if ($('.activity_container').hasClass("dnone")) {
                    $('.activity_container').removeClass("dnone");
                    $('#title').addClass("show_tip");
                    $(".tipContainer").addClass('active_tip');
                    $(".tipContainer> img").attr('src', 'images/up_arrow.svg');
                    $(".tipContainer").attr('aria-expanded', 'true');
                } else {
                    $('.activity_container').addClass("dnone");
                    $('#title').removeClass("show_tip");
                    $(".tipContainer").removeClass("active_tip");
                    $(".tipContainer> img").attr('src', 'images/down_arrow.svg');
                    $(".tipContainer").attr('aria-expanded', 'false');
                }
            }
        })
        $(".zoomImg").unbind().bind('click keydown touchstart', imageModal);
        // $(".qdraglabel .zoomImg").unbind().bind('click keydown touchstart', imageModal);
        // $(".qhint").bind('click keydown touchstart', function (e) {
        //     openHint(e, $(this), 'optionHint');
        // });
        // $(".dragspot .zoomTextButton").unbind().bind('click touchstart keydown touchstart', zoomTextModal);

        // $(".helpHintLink").bind('click keydown touchstart', function (e) {
        //     openHint(e, $(this), 'helpHint');
        // });
        $(".audio").unbind().bind('click touchstart', playAudio);
        $(".page-no").unbind().bind('click  keydown touchstart', setPageNo);

        // $(".audio").attr('aria-label', 'Press space or enter to play audio');
        // $(".avatar_popup").bind('keydown click', common.avtarPopup);
        // $(".avatar_popup").bind('keydown click', common.playAudio);
        $('.prevPage').bind('click keydown', fnBackPage);
        $('.nextPage').bind('click keydown', fnNextPage);
        $(".nextPage").attr('aria-label', 'Next page. ' + clickTouchInst + ' to move to next page.').attr('title', 'Next page.');
        $(".prevPage").attr('aria-label', 'Previous page. ' + clickTouchInst + ' to move to previous page.').attr('title', 'Previous page.');
        $(".dragspotWrapper .dragspot").bind('keydown click touchstart', handleDragByKey);
        // $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        // $(".dropspot").bind('click touchend', handleDropByClick);
        $(".quiz-container").bind('touchmove', handleScrollPaneTouchMove);
    }
    function playAudio(e) {
        if (e.type === 'click' || e.type === 'touchstart') {
            common.playAudio(e);
        }
    }
    function setHeight () {
        var wrapperHeight = $('#questionWrapper').innerHeight();
        var quizeHeight = $('#quiz-container').outerHeight();
        // $('.drag_tray').css({minHeight:(wrapperHeight - ( quizeHeight  ) )+'px'});
    
    }
    function imageModal(e) {
        if (e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32)) { } else {
            e.preventDefault();
            e.stopImmediatePropagation();
            e.stopPropagation();
            currentObjFocus = $(this);
            $('body').addClass('stop-scrolling');
            var $modal = $('<div id="myModal" class="modal">\
             <div class="modal-content" role="dialog" aria-labelledby="modalText" aria-modal="true">\
                <p id="modalText" class="screenhide screenstart" aria-label=" Image pop-up open">&nbsp;</p> \
                <img class="modalImage" alt="'+ $(this).attr("alt") + '" src="' + $(this).attr("data-src") + '"/>\
                <div class="modalClose" aria-label="'+ $(this).attr("alt") +'ed Close Popup" role="button"><img alt=""  src="images/popup_close_button.svg" /></div> \
            </div>\
            </div>');
            $(".drag_tray").append($modal);
            $("#myModal").unbind().bind('keydown click',function (e) {
                if(e.keyCode == 9 || (e.shiftKey && e.keycod == 9)){
                    e.preventDefault();
                    $('.modalClose').focus();
                    return;
                }
                if(e.keyCode === 27 || e.type =="click") {
                    $('body').removeClass('stop-scrolling');
                    maincontainer.removeAttr('aria-hidden');
                    $modal.css("display", "none");
                    addTabIndex();
                    setTimeout(function () {
                        currentObjFocus.focus();
                    }, 100);
                    $(this).remove();
                   
                }
            })
            $(".modalClose").bind("click keydown touchstart", function (e) {
                if (e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32)) { } else {
                    // if(e.keyCode == 9){
                        e.preventDefault();
                        e.stopPropagation()
                    //     return;
                    // }

                    $('body').removeClass('stop-scrolling');
                    maincontainer.removeAttr('aria-hidden');
                    // addTabIndex();
                    setTimeout(function () {
                        currentObjFocus.focus();
                    }, 100);
                    $(this).parent().parent().remove();
                }
            });
            $modal.css("display", "block");
            currentTabIndex = $(this).attr('tabindex');
            removeTabIndex();
            $('.modalClose').attr('tabindex', 0);
            $('.modal-content').attr('tabindex', 0);
            $('.modal-content').focus();
            maincontainer.attr('aria-hidden', true);
            setTimeout(function () {
                $('.modal-content').removeAttr('tabindex');
                $('.modalClose').focus();
                $(document).find('body').addClass('show-focus-outlines');
            }, 200);
        }
    }
    function openHint(e, object, type) {
        //if(e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32))
        if (e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32)) { } else {
            e.preventDefault();
            e.stopImmediatePropagation();
            e.stopPropagation();

            currentObjFocus = object;
            var popupTitle;
            var hintString = '';
            var hintAudio = '';
            var modalClass;
            switch (type) {
                case 'optionHint':
                    popupTitle = lang.Hint;
                    var option_id = $(object).attr('data-option-id');
                    hintString = config.data.option_hint[option_id];
                    hintAudio = config.data.opt_hint_audio[option_id];
                    modalClass = 'qhintpopup';
                    if (config.data.opt_hint_audio[option_id] != '')
                        hintAudio = '<div data-src="audio/' + config.data.opt_hint_audio[option_id] + '" class="audio audio_drag noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></div>';
                    break;
                case 'helpHint':
                    popupTitle = lang.aboutThisActivity;
                    var hint_str = '';
                    for (var h = 0; h < config.data.hint_type.length; h++) {
                        hintString += '<p class="tooltip_popupContent" aria-label="' + config.data.hint_text_image[h] + '">';
                        if (config.data.hint_type[h] == 'image') {
                            hint_str = '<img src="images/' + config.data.hint_text_image[h] + '" alt="' + config.data.hint_audio_alt[h] + '" style="max-width: 100%;" />';
                        } else {
                            hint_str = ' ' + config.data.hint_text_image[h] + ' ';
                            if (config.data.hint_audio_alt[h] != '') {
                                hint_str += '<span data-src="audio/' + config.data.hint_audio_alt[h] + '" class="audio audio_about_activity noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></span>';
                            }
                        }
                        hintString += hint_str;
                        hintString += '</p>';
                    }
                    modalClass = 'hint_and_tips';
                    hintAudio = config.data.hint_tips_audio;
                    break;
                case 'zoomText':
                    modalClass = 'hint_and_tips';
                    popupTitle = '';
                    var popupContents = $(object).parents(".dragspot").find(".dragspot_txt").html();
                    //var result = popupContents.replace(/(<a[^>]+?>|<a>|<\/a>)/img, "");
                    var result = $(object).parents(".dragspot").find(".dragspot_txt").attr("data-baseText");
                    hintString += '<p class="tooltip_popupContent">' + result + '</p>';
                    hintAudio = ($(object).parents(".dragspot").find(".audio").length > 0) ? '<div data-src="' + $(object).parents(".dragspot").find(".audio").attr("data-src") + '" class="audio audio_drag noTab"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt=""></img></div>' : '';
                    break;
            }


            var popupImg = (type == 'zoomText') ? 'close_callout' : 'close_white';
            var popupHeader = (type == 'zoomText') ? '' : '<div class="modalImage"> </div> <h1 class="popupHeader" id="inst_dialog_label">' + popupTitle + '</h1>';

            var hintAudiostr = '';
            if (hintAudio != '')
                var hintAudiostr = '<div data-src="audio/' + hintAudio + '" class="audio audio_hintPopup noTab" aria-hidden="true"><img src="../../images/audio_blue.svg" width="100%" height="100%" alt="" /></div>';

            var $modalDiv = $('<div id="myHintModal" class="modal" role="dialog" aria-labelled="inst_dialog_label popup_content_body" tabindex="-1">\
                <div class="tooltip-model-content '+ modalClass + '"> \
                    '+ popupHeader + ' \
                    <div class="hintpopupContent">'+ hintString + ' ' + hintAudio + '</div> \
                  <div class="tooltipModalClose tabindex" role="button" aria-label="Close Popup. '+ clickTouchInst + ' to close the popup."><img alt="" src="../../images/' + popupImg + '.svg" /></div>\
                </div> \
                </div>');
            $("body").append($modalDiv);


            $(".tooltipModalClose").bind("click keydown touchstart", function (e) {
                if (e.type === 'keydown' && (e.keyCode !== 13 && e.keyCode !== 32)) {
                } else {
                    common.stopAudio();
                    $('body').removeClass('stop-scrolling');
                    $(this).parent().parent().remove();
                    addTabIndex();
                    setTimeout(function () {
                        currentObjFocus.focus();
                    }, 100);
                    maincontainer.removeAttr('aria-hidden');
                }
            });
            $modalDiv.css("display", "block");
            currentTabIndex = object.attr('tabindex');
            removeTabIndex();
            //$(".audio").attr('aria-label', 'Press space or enter to play audio');
            //$('#myModal .popupHeader').attr('tabindex',0);
            $("#myModal .helpPopupImg").attr("tabindex", 0);
            //$('#myModal .audio').attr('tabindex',0);
            //$('#myModal .screenhide').attr('tabindex',0);
            $('tooltipModalClose').attr('tabindex', 0);

            if (e.type === 'keydown') {
                $(document).find('body').addClass('show-focus-outlines');
            }
            setTimeout(function () {
                $('#myHintModal').focus();
            }, 100);

            maincontainer.attr('aria-hidden', true);
            $(".audio").unbind().bind('click touchstart', playAudio);
            $(".audio").attr("tabindex", "-1");
            $(".tooltipModalClose").attr("tabindex", "0");
        }
    }

    function showAnsCompliment(isCorrect, ele) {
        var droppedAns = isCorrect;
        var correctArr = ["Amazing", "Fantastic!", "Wow! You canbe proud of your learning."];
        var wrongArr = ["So close!", "Try again", "Oops! Try again"];
        var wrongArr = [];
        for (var k = 1; k < 4; k++) {
            if (config.data["incorrect_feedback" + k] != '') {
                var data = {
                    msg: config.data["incorrect_feedback" + k],
                    audio: config.data["incorrect_feedback" + k + "_audio"]
                }
                wrongArr.push(data);
            }

        }
        statusContainer.removeClass("dnone");
        questionWrapper.addClass("result-height");
        var audioName = "";
        if (isCorrect === "true") {
            // comDiv.text(correctArr[Math.floor(Math.random() * 3)]);
            comDiv.text(config.data.correct_feedback);
            audioName = config.data.correct_feedback_audio;
            comDiv.addClass("right-ans");
            correctAnsArr[questionNo] = true;
            $(ele).parent().addClass("correct-ans");
            $(ele).parent().find(".status-btn").addClass("correct-icon");
            statusContainer.find(".status-text").text("next");
            statusContainer.find(".status-back").addClass("next").removeClass('back').unbind().bind('keydown click ', fnNext);
            statusContainer.find(".audio-btn").attr('data-src', 'audio/' + config.data.next_audio);
            // $('.status-back .next');
        } else {
            if (wrongArr.length > 0) {
                var randomMsg = wrongArr[Math.floor(Math.random() * wrongArr.length)];
                comDiv.text(randomMsg.msg);
                audioName = randomMsg.audio;
            }
            comDiv.addClass("wrong-ans");
            correctAnsArr[questionNo] = false;
            $(ele).parent().find(".status-btn").addClass("incorrect-icon");
            $(ele).parent().addClass("incorrect-ans");
            statusContainer.find(".status-text").text("try again");
            statusContainer.find(".status-back").addClass("back").removeClass('next');
            $('.back').unbind().bind('keydown click ', tryAgain);
            statusContainer.find(".audio-btn").attr('data-src', 'audio/' + config.data.try_again_audio);
        }
        // $(".correct-icon ").attr("tabindex", "0");
        // $(".incorrect-icon ").attr("tabindex", "0");
        $(".drag_tray").addClass("status_active");
        comDiv.append('<div class="audioContainer audio-btn audio " data-src="audio/' + audioName + '" aria-hidden="true"><img src="images/audio_button.svg" alt=""></div>');
        $(".dragspotWrapper .dragspot").unbind('keydown click touchstart', handleDragByKey);
        comDiv.focus();
        setTimeout(() => {
            $(".qtitle").removeClass("dnone");
            
        }, 2000);
        // $(".audio").unbind().bind('click touchstart', playAudio);
    }
    function tryAgain(e) {
        if (e.type == "click" || e.keyCode == 13 || e.keyCode == 32) {
            statusContainer.addClass("dnone");
            questionWrapper.removeClass("result-height");
            $(".incorrect-ans").removeClass("incorrect-ans");
            $(".incorrect-icon").removeClass("incorrect-icon");
            $(".drag_tray").removeClass("status_active");
            $(".inactive").removeAttr("aria-hidden");
            $(".inactive").removeClass("inactive");
            comDiv.removeClass("wrong-ans").text('');
            $(".dragspotWrapper .dragspot").bind('keydown click touchstart', handleDragByKey);
            $(".status-btn ").removeAttr("tabindex");
            $(".answer-container  .dragspotWrapper").each(function () {
                $(this).find(".zoomImg").attr("tabindex", "0");
                $(this).find(".dragspot").attr("tabindex", "0");
                $(this).find(".zoomImg").removeAttr("aria-hidden");
                $(this).find(".dragspot_txt").removeAttr("aria-hidden");
            });
            setTimeout(function () {
                $($(".answer-container  .dragspotWrapper .dragspot")[0]).focus();
            }, 500);
        }

    }

    function playAgain(e) {
        if (e.type == "click" || e.keyCode == 13 || e.keyCode == 32) {
            statusContainer.addClass("dnone");
            questionWrapper.removeClass("result-height");
            statusContainer.find(".status-back").addClass("next").removeClass('back').removeClass('again');
            var perPageQues = parseInt(config.data.questionPerPage);
            questionNo = pageNo * perPageQues - perPageQues;
            var endQues = pageNo * perPageQues;
            correctAnsArr = new Array(config.data.question_list.length).fill(false);
            createQues();
            setHeight();
            setTimeout(() => {
                addEvents();
            }, 200);
        }
    }

    function displayReadMoreIcon() {
        $('.answer-container .dragspot_txt').css('max-height', '93px');
        $('.answer-container .dragspot_txt').css('height', '70px');
        $('.answer-container .dragspot_txt').each(function () {
            $(this).parents('.dragspot').css('padding', '0px');
            $(this).css({
                'display': 'block',
                'overflow': 'hidden',
                'padding': '3px 23px 10px 5px',
                'float': 'left'
            });
            $(this).parents('.dragspot').css({ 'min-width': '200px', 'display': 'inline-block', 'padding': '0px' });
            $(this).parents('.dragspotWrapper').css({ 'min-width': '200px' });
            $(this).parents('.dragspot').find('.qdraglabel').css({ 'float': 'left', 'margin': '10px', 'margin-right': '0px' });
            if (!$(this).parents('.dragspot').find('.qdraglabel').length) {
                $(this).css({ 'width': '90%' });
            }
            else {
                $(this).parents('.dragspot').find('.qdraglabel').css({ 'width': '62px', 'height': '62px' });
                $(this).parents('.dragspot').find('.qdraglabel img').css({ 'width': '60px', 'height': '60px' });
                var imgwidth = $(this).parents('.dragspot').find('.qdraglabel').width();
                var parentWidth = $(this).parents('.dragspot').width();
                var txtWidth = parentWidth - imgwidth - 25;
                if ($(window).innerWidth() < 500)
                    txtWidth = parentWidth - imgwidth - 25;
                $(this).css({ 'width': txtWidth + 'px', 'padding-left': '0px' });
            }
            var numberOflines = getRows($(this));

            var ntext = $(this).parents('.dragspot').find('.dragspot_txt').length,
                ndraglabel = $(this).parents('.dragspot').find('.qdraglabel').length;
            vDragspotImageEle = $(this).parents('.dragspot').find('.qdraglabel');
            $(this).parents('.dragspot').css('max-height', 'initial');
            if (ntext > 0 && ndraglabel > 0) {
                // Image with text
                $(this).css({ 'display': 'block', 'padding': '0px' });
                var txtWidth = $(this).parents('.dragspot').width() - $(this).parents('.dragspot').find('.qdraglabel').width() - 45;
                $(this).css('width', txtWidth + 'px');
            }
            else if (ndraglabel > 0) {
                // Image only
                /*$(this).parents('.dragspot').find('.qdraglabel').css({'width':'100%'})
                $(this).parents('.dragspot').css({'min-width':'auto'})*/
            } else {
                //text only
                if ($(window).innerWidth() < 500)
                    $(this).css({ 'padding': '0px 23px 0px 5px' });
            }
            $(this).parents('.dragspot').find('.zoomTextButton').css('display', 'none');
            if (numberOflines > 3) {
                $(this).parents('.dragspot').find('.zoomTextButton').css('display', 'block');
            }
        });

        $('.quiz-container .dragspot_txt').css('max-height', '93px');
        $('.quiz-container .dragspot_txt').css('height', '90px');
        $('.quiz-container .dragspot_txt').each(function () {
            $(this).parents('.dragspot').css('padding', '0px');
            $(this).css({
                'display': 'block',
                'overflow': 'hidden',
                'padding': '3px 23px 10px 5px',
                'max-height': '90px',
                'float': 'left'
            });
            $(this).parents('.dragspot').css({ 'min-width': '200px', 'display': 'inline-block', 'padding': '0px' });
            $(this).parents('.dragspot').find('.qdraglabel').css({ 'float': 'left', 'margin': '10px', 'margin-right': '0px' });
            if (!$(this).parents('.dragspot').find('.qdraglabel').length) {
                $(this).css({ 'width': '90%' });
            } else {
                $(this).parents('.dragspot').find('.qdraglabel').css({ 'width': '82px', 'height': '82px', 'margin': '10px' });
                $(this).parents('.dragspot').find('.qdraglabel img').css({ 'width': '80px', 'height': '80px' });
                var imgwidth = $(this).parents('.dragspot').find('.qdraglabel').width();
                var parentWidth = $(this).parents('.dragspot').width();
                var txtWidth = parentWidth - imgwidth - 25;
                if ($(window).innerWidth() < 500) {
                    txtWidth = parentWidth - imgwidth - 25;
                }
                $(this).css({ 'width': txtWidth + 'px', 'padding-left': '0px' });
            }
            var numberOflines = getRows($(this));

            var ntext = $(this).parents('.dragspot').find('.dragspot_txt').length,
                ndraglabel = $(this).parents('.dragspot').find('.qdraglabel').length;
            vDragspotImageEle = $(this).parents('.dragspot').find('.qdraglabel');
            $(this).parents('.dragspot').css('max-height', 'initial');
            if (ntext > 0 && ndraglabel > 0) {
                // Image with text
                $(this).css({ 'display': 'block', 'padding': '0px' });
                var txtWidth = $(this).parents('.dragspot').width() - $(this).parents('.dragspot').find('.qdraglabel').width() - 45;
                $(this).css('width', txtWidth + 'px');
            } else if (ndraglabel > 0) {
                // Image only
            } else {
                //text only
                if ($(window).innerWidth() < 500)
                    $(this).css({ 'padding': '0px 23px 0px 5px' });
            }
            $(this).parents('.dragspot').find('.zoomTextButton').css('display', 'none');
            if (window.innerWidth <= 600) {
                if (numberOflines >= 4) {
                    $(this).parents('.dragspot').find('.zoomTextButton').css('display', 'block');
                }
            } else {
                if (numberOflines > 4) {
                    $(this).parents('.dragspot').find('.zoomTextButton').css('display', 'block');
                }
            }
        });
        $('.answer-container .qdraglabel').each(function () {
            $(this).css({ 'width': '62px', 'height': '62px', 'margin': '10px' });
            $(this).find('img').css({ 'width': '60px', 'height': '60px' });
            if ($(this).parents('.dragspot').find('.dragspot_txt').text() == '') {
                //image only tiles
                $(this).css({ 'margin': 'auto', 'float': 'none', 'width': '100%', 'height': '100%' });
                $(this).find('img').css({ 'width': '100%', 'height': '100%' });
                $(this).parent().css({ 'min-width': 'auto' });
                $(this).parent().parent().css({ 'min-width': 'auto' });
            }
        });
        $(".dragspot .zoomTextButton").unbind().bind('click keydown touchstart', zoomTextModal);
        $('.dropspot .dragspot').css('min-width', 'auto');
    }

    function getRows(selector) {
        var elementId = $(selector).attr('id');
        var height = (document.getElementById(elementId).scrollHeight - 20);
        var line_height = $(selector).css('line-height');
        line_height = parseFloat(line_height)
        var rows = height / line_height;
        return rows;
        //return Math.round(rows);
    }

    function setQuizContainerHeight() {
        var offsetvar = 20;
        if ($(window).innerWidth() < 500) {
            offsetvar = 10;
        }
        setTimeout(function () {
            /*parentBottomOffset = window.parent.$('.bottom-container').offset().top;
            var quizHeight = parentBottomOffset - ( ($('#title').height() )+$('.drag_tray').height()+$('.qtitle').height()+$('.bottom-container').height()+offsetvar-1);
            quizHeight += $('.bottom-container').height()-10;
            $('#quiz-container').css({'height' :quizHeight+50+'px'});*/

            quizHeight = $('.bottom-container').offset().top - ($(".answer-container").offset().top + $(".answer-container").height());
            quizHeight -= 8;
            // $('#quiz-container').css({ 'height': quizHeight + 'px' });
        }, 100);
        setTimeout(function () {
            /*parentBottomOffset = window.parent.$('.bottom-container').offset().top;
            var quizHeight = parentBottomOffset - ( ($('#title').height() )+$('.drag_tray').height()+$('.qtitle').height()+$('.bottom-container').height()+offsetvar);
            quizHeight += $('.bottom-container').height()-10;*/

            quizHeight = $('.bottom-container').offset().top - ($(".answer-container").offset().top + $(".answer-container").height());
            quizHeight -= 10;
            // $('#quiz-container').css({ 'height': quizHeight + 'px' });
        }, 200);
    }
    app.setParameters = function () {
        var innerWidth = $(window).innerWidth();
        if (config.data.dnd1_activity_type == 'image') {
            if ((innerWidth > 0) && (innerWidth <= 680)) {
                frameDragspot = 1;
            }
            else if ((innerWidth > 680) && (innerWidth <= 1000)) {
                frameDragspot = 3;
            }
            else {
                frameDragspot = 5;
            }
        }
        else {
            if ((innerWidth > 0) && (innerWidth <= 680)) {
                frameDragspot = 1;
            }
            else if ((innerWidth > 680) && (innerWidth <= 1000)) {
                frameDragspot = 2;
            }
            else {
                frameDragspot = 3;
            }
        }
        if ((innerWidth > 0) && (innerWidth <= 770)) {
            quizLayout = '1 Column';
        }
        else {
            quizLayout = '2 Column';
        }
    }
    function createFrames() {
        var j = 0;
        var k = 0;
        var firstFrameDragElement = frameDragspot;
        DragSet = '';

        var ariaLabelContent;

        DragSet += '<ul class="frame headerFrame' + j + '">';
        for (var i = 0; i < config.data.question_list[questionNo].options.length; i++) {
            var options = config.data.question_list[questionNo].options
            var text = config.data.question_list[questionNo].options[i];
            ariaLabelContent = 'aria-label="' + options[i].imgAlt + '"';
            console.log(options.img, ariaLabelContent);

            DragSet += '<li class="dragspotWrapper" data-id="' + i + '"><div ' + ariaLabelContent + ' aria-grabbed="true" class="dragspot tabindex" tabindex="0" role="button" data-answer="' + options[i].correct + '">';
            DragSet += '<img id="drag_txt_' + i + '" alt="' + options[i].imgAlt + '"  src="images/' + options[i].img + '" class="dragspot_txt" data-baseText="' + text + '">';

            DragSet += '</img></div>';
            DragSet += '<div class="btn-container"></div>';
            DragSet += '<div class="btn-container"><div class="audioContainer audio-btn audio" data-src="audio/' + options[i].audio + '" aria-hidden="true"  ><img src="images/audio_button.svg" alt=""></div><div class="zoom-box"><img class="zoomImg" src="images/zoom_icon.svg" alt="' + options[i].imgAlt + ' zoom" role="button" data-src="images/' + options[i].img + '"></div><div class="status-btn "></div></div></li>';

        }
        DragSet += '</ul>';
        setTimeout(() => {
            $(".dragspotWrapper .dragspot").bind('keydown click touchstart', handleDragByKey);
            // $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        }, 500);
        setHeight();

    }
    app.updateFrames = function () {
        if (!answerContainer) { } else {
            if($(".frame").hasClass("allAnsFrame")) {
                var perPageQues = parseInt(config.data.questionPerPage);
                var startQues = pageNo * perPageQues - perPageQues;
                var endQues = pageNo * perPageQues;
                var queArr = config.data.question_list.slice(startQues, endQues)
                var correctArr = correctAnsArr.slice(startQues, endQues);
                if (correctArr.length <= perPageQues && correctArr.length === queArr.length) {
                    var isFinish = false;
                    var count = 0;
                    correctArr.forEach(ele => {
                        if (ele) {
                            count += 1;
                        }
                    })
                    if (correctArr.length == count) {
                        isFinish = true;
                        $(".dragspotWrapper .dragspot").unbind('keydown click touchstart', handleDragByKey);
                        statusContainer.find(".audio-btn").attr('data-src', 'audio/' + config.data.play_again_audio);
                        statusContainer.find(".status-back").addClass("again").removeClass('back').removeClass('next');
                        statusContainer.find(".status-text").text("play again");
                        $(".again").unbind().bind("click keydown", playAgain);
                        showAllAns(startQues, endQues);
                    }
                }
            } else{

           
            var j = 0, i = 0;
            nSlideCounter = 0;
            var currentFrame = $(".frame:visible").index();
            DragSet = '';
            var dragspots = $('.answer-container .dragspot').length;

            DragSet += '<ul class="frame headerFrame' + j + '">';
            var currentHTML;
            var currentDataAnswer;
            var currentDataSrc;
            var ariaLabelContent;
            $('.answer-container .dragspot').each(function () {
                currentHTML = $(this).html();
                currentDataAnswer = $(this).attr('data-answer');
                currentDataSrc = $(this).parent().find(".zoomImg").data("src");
                currentDataAlt = $(this).parent().find(".zoomImg").attr("alt");
                currentAudioDataSrc = $(this).parent().find(".audio-btn").data("src");
                // if (!isMobile()) {
                ariaLabelContent = 'aria-label="' + $(this).find(".dragspot_txt").attr("alt") + '"';
                // } else {
                //     ariaLabelContent = 'aria-labelledby="' + $(this).text().trim() + '"';
                // }

                DragSet += '<li class="dragspotWrapper" data-id="' + i + '"><div aria-grabbed="true" role="button" class="dragspot tabindex" tabindex="0" ' + ariaLabelContent + ' data-answer="' + currentDataAnswer + '">' + currentHTML + '</div>';
                // if ((i + 1) % frameDragspot == 0) {
                //     DragSet += '</ul>';
                //     j++;
                //     if (typeof $('.answer-container .dragspot')[i + 1] != 'undefined') {
                //         DragSet += '<ul class="frame headerFrame' + j + '">';
                //     }
                // }
                DragSet += '<div class="btn-container"><div class="audioContainer audio-btn audio " data-src="' + currentAudioDataSrc + '" aria-hidden="true" ><img aria-hidden="true" alt="" src="images/audio_button.svg"></div><div class="zoom-box"><img class="zoomImg" tabindex="0"  src="images/zoom_icon.svg" alt="' + currentDataAlt + '" role="button" data-src="' + currentDataSrc + '"></div><div class="status-btn "></div></div></li>';
                i++;
            });
            DragSet += '</ul>';
            answerContainer.html('');

            answerContainer.append(DragSet);
            aSlidesArray = new Array();
            $(".answer-container .frame").each(function () {
                $(this).css('display', 'none')
                aSlidesArray.push($(this))
                nCount++;
            });
            //$(".answer-container .frame:nth-child("+(currentFrame+1)+")").show();    
            $(".answer-container .frame:nth-child(1)").show();
            fnCheckNextBack();
            setHeight();
            // if ($('.frame').length == 1) {
            //     DisableLeftArrow();
            //     DisableRightArrow();
            // }
            var dropspotWidth = $($('.dropspot')[0]).width();
            var dropspotHeight = $($('.dropspot')[0]).height();
            $('.dragspotWrapper').css({ "width": dropspotWidth + 'px', 'min-width': '200px' });
            // $('.dragspotWrapper').css("height", '62px');

            $('.dragspot').css({ "width": dropspotWidth + 'px', 'min-width': '200px' });
            $('.dragspot').css("height", dropspotHeight + 'px');
            // $('.dragspotWrapper .dragspot').css("height", '82px');

            // if (config.data.dnd1_activity_type == 'image') {
            //     $('.dragspot').css({ 'width': '100px', 'padding': '0px' });
            //     $('.dragspotWrapper').css({ 'margin': '10px 26px' });
            // }
            $(".audio").unbind().bind('click touchstart', playAudio);
            $('.answer-container .frame').each(function () {
                if ($(this).is(':empty')) {
                    $(this).remove()
                }
            });
            if ($('.answer-container .frame').length == 0 || $('.answer-container .frame').length == 1) {

            }
            addTabIndex();
            $(".zoomImg").unbind().bind('click keydown touchstart', imageModal);

            var avatar_width = $('#data-elements').width() - $('.qtitle_image').width() - 25;
            $('.avatar_text').css('width', avatar_width);

            var innerWidth = $(window).innerWidth();

            if (config.data.dnd1_activity_type == 'image') {
                $('.draglabel').css('margin', '0px 0px 16px 27px');

                if ((innerWidth > 0) && (innerWidth <= 600)) {
                    $('.draglabel').css({ 'width': '90%' });
                    $('.draglabel').css('margin-left', '10%');
                }
                else if ((innerWidth > 600) && (innerWidth <= 1000)) {
                    $('.draglabel').css({ 'width': '42%' });
                }
                else {
                    $('.draglabel').css({ 'width': '30%' });
                }
            }
            $(".comp_div").removeClass("wrong-ans right-ans").html("");
            $(".status-container").addClass("dnone");
            $("#questionWrapper").removeClass("result-height");
            $(".dragspotWrapper .dragspot").bind('keydown click touchstart', handleDragByKey);
            // $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
            setQuizContainerHeight();
            displayReadMoreIcon();
        }
        }
    }

    function showAllAns(start, end) {
        var j = 0;
        var k = 0;
        var firstFrameDragElement = frameDragspot;
        DragSet = '';

        var ariaLabelContent;

        DragSet += '<ul class="frame allAnsFrame">';
        var qAll = config.data.question_list.slice(start, end);
        for (j; j < qAll.length; j++) {
            var ques = qAll[j];
            for (var i = 0; i < ques.options.length; i++) {
                var options = ques.options
                var text = ques.options[i];
                if (options[i].correct == "true") {
                    ariaLabelContent = 'aria-label="' + options[i].imgAlt + '. "';
                    DragSet += '<li class="dragspotWrapper correct-ans" data-id="' + i + '"><div ' + ariaLabelContent + ' aria-grabbed="true" class="dragspot tabindex" tabindex="0" data-answer="' + options[i].correct + '">';
                    DragSet += '<img id="drag_txt_' + i + '" alt="' + options[i].imgAlt + '"  src="images/' + options[i].img + '" class="dragspot_txt" data-baseText="' + text + '">';
                    DragSet += '</img></div>';
                    DragSet += '<div class="btn-container"><div class="audioContainer audio-btn audio" data-src="audio/' + options[i].audio + '" aria-hidden="true"><img src="images/audio_button.svg" alt=""></div><div class="zoom-box"><img class="zoomImg" src="images/zoom_icon.svg" alt="zoom" role="button" data-src="images/' + options[i].img + '"></div><div class="status-btn correct-icon"></div></div></li>';

                }
            }
        }
        DragSet += '</ul>';
        answerContainer.html('');

        answerContainer.append(DragSet);
        $(".zoomImg").unbind().bind('click keydown touchstart', imageModal);
        $(".zoomImg").attr("tabindex", "0");
        $(".audio").unbind().bind('click touchstart', playAudio);
        $(".dragspotWrapper .dragspot").removeAttr('tabindex');
        setTimeout(() => {
            $(".dragspotWrapper .dragspot").unbind('keydown click touchstart', handleDragByKey);
            // $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        }, 500);

    }
    function shuffle(array) {
        var currentIndex = array.length,
            temporaryValue, randomIndex;
        while (0 !== currentIndex) {
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex -= 1;
            temporaryValue = array[currentIndex];
            array[currentIndex] = array[randomIndex];
            array[randomIndex] = temporaryValue;
        }
        return array;
    }

    function handleScrollPaneTouchMove(e) {
        tempDragKey = null;
    }

    var inTap = false;
    function handleTap(e) {
        //return;
        if (isMobile() && e.type == "click") {

            return;
        }
        if ($(this).parent().hasClass("ui-draggable-disabled")) {
            return;
        }

        if (!optMoved) {
            if (tempDragKey == null) {
                tempDragKey = $(this).parent();

                if (!tempDragKey.hasClass("dragspot")) {
                    tempDragKey = $(this).parent().find(".dragspot");
                }
                if (!$(this).parent().parent().parent().parent().hasClass("answer-container"))
                    inTap = true;
                //e.stopPropagation();
            }
        }
    }
    var itemInDrop = false;



    function handleDropByClick(e) {
        //return;
        if (isMobile() && e.type == "click") {

            return;
        }

        if (!optMoved) {
            if (!inTap) {
                if (tempDragKey) {
                    var thisDropID = $(this).attr('id');
                    placeOptionToDropLocation(tempDragKey, $("#" + thisDropID));



                }
                tempDragKey = null;
            }
            inTap = false;
        }
    }




    function handleRemoveDragByKey(e) {
        if (e.keyCode !== 13 && e.keyCode !== 32) {
            return false;
        }
        var newDragspotWrapper = $('<li>', { class: 'dragspotWrapper' });
        newDragspotWrapper.attr('data-id', $(this).attr('data-answer'));
        $(this).parent().attr("dropped", "false");
        $(this).removeClass('correct incorrect-answer');
        newDragspotWrapper.append($(this));
        if ($(".answer-container .frame").length > 0) {
            $(".answer-container .frame:nth-child(1)").prepend(newDragspotWrapper);
            if ($(".dropspot .dragspot").length < 1) {
                // resetButton.addClass("disabled").attr("disabled", "disabled");
            }
        }
        else {
            if ($(".answer-container .frame").length < 1) {
                var newFrame = $('<ol>', { class: 'frame headerFrame0' });
                newFrame.append(newDragspotWrapper);
                $(".answer-container").append(newFrame);
                submitButton.addClass('disabled');
                submitButton.attr('disabled', 'disabled');
            }
        }
        app.updateFrames();
        addTabIndex();
        $(".dragspotWrapper .dragspot").bind('keydown click touchstart', handleDragByKey);
        // $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        e.preventDefault();
        e.stopPropagation();
    }

    function handleDragByKey(e) {
        console.log("dddddd")
        if (e.type === "keydown" && (e.keyCode !== 13 && e.keyCode !== 32)) {
        } else {
            e.preventDefault();
            e.stopPropagation();
            e.stopImmediatePropagation();
            DragID = $(this).parent().attr("data-id");
            var isCorrect = $(this).attr("data-answer");
            DropListContainer = "";
            $(".answer-container  .dragspotWrapper").each(function () {
                if ($(this).attr("data-id") != DragID) {
                    $(this).attr("aria-hidden", "true");
                    $(this).addClass("inactive");
                    $(this).find(".zoomImg").removeAttr("tabindex");
                    $(this).find(".audioContainer").removeAttr("tabindex");
                    $(this).find(".zoomImg").attr("aria-hidden", "true");
                    $(this).find(".dragspot_txt").attr("aria-hidden", "true");
                    $(this).find(".dragspot").removeAttr("tabindex");
                    $(this).find(".zoomImg").unbind('click keydown touchstart', imageModal);
                    $(this).find(".audio").unbind('click touchstart', playAudio);
                } else {
                    $(this).attr("aria-hidden", "false");
                    $(this).removeClass("inactive");
                }
            })
            $(".frame").addClass("allAnsFrame");
            showAnsCompliment(isCorrect, this);
        }
    }



    function placeOptionToDropLocation(optionInDrag, dropLocation) {
        if (dropLocation.children().hasClass("ui-draggable-disabled")) {
            return;
        }

        if (optionInDrag.parent().hasClass("dropspot")) {
            optionInDrag.parent().attr("dropped", "false");
            optionInDrag.removeClass('incorrect-answer');
            optionInDrag.parent().addClass('dotted-frame');
            //$('.dropspot').removeAttr("tabindex");
        }

        optionInDrag.attr("aria-grabbed", 'true');
        $('.dropspot').attr("aria-dropeffect", 'none');

        if (dropLocation.attr("dropped") != 'true') {
            dropLocation.attr("dropped", 'true');
        } else {
            var newDragspotWrapper = $('<li>', { class: 'dragspotWrapper' });
            newDragspotWrapper.attr('data-id', dropLocation.children().attr('data-answer'));
            //$(this).attr("dropped", "false");
            dropLocation.children().removeClass('correct incorrect-answer');
            newDragspotWrapper.append(dropLocation.children());



            if ($(".answer-container .frame").length > 0) {
                $(".answer-container .frame:nth-child(1)").prepend(newDragspotWrapper);
            } else {
                if ($(".answer-container .frame").length < 1) {
                    var newFrame = $('<ul>', { class: 'frame headerFrame0' });
                    newFrame.append(newDragspotWrapper);
                    $(".answer-container").append(newFrame);
                    submitButton.addClass('disabled');
                    submitButton.attr('disabled', 'disabled');
                }
            }

        }


        dropLocation.removeClass('dotted-frame');
        optionInDrag.addClass('correct');
        optionInDrag.position({ of: dropLocation });
        optionInDrag.appendTo(dropLocation);
        optionInDrag.css({ 'top': '0px', 'left': '0px', 'position': 'absolute' });
        var correct_answer = dropLocation.attr('data-answer');
        var dropped_answer = dropLocation.find('.dragspot').attr('data-answer');
        if (correct_answer == dropped_answer) {
            dropLocation.find('.dragspot').addClass('correct-answer');
        }
        else {
            dropLocation.find('.dragspot').addClass('incorrect-answer');
            optionInDrag.removeClass('incorrect-answer');
            optionInDrag.parent().addClass('dotted-frame');
            $('.dropspot').removeAttr("tabindex");
            addTabIndex();
        }

        autoUpdatedDragBoxForTab();
        // resetButton.removeClass('disabled');
        // resetButton.removeAttr('disabled').attr("tabindex", "0");
        var all_dropped = true;
        $('.dropspot').each(function () {
            if ($(this).attr("dropped") != 'true')
                all_dropped = false;
        });
        all_correct = true;
        $(".dropspot").each(function () {
            var correct_answer = dropLocation.attr('data-answer');
            var dropped_answer = dropLocation.find('.draggable').attr('data-answer');
            if (correct_answer != dropped_answer) {
                all_correct = false;
            }
        });
        if (all_dropped) {
            // submitButton.removeClass('disabled');
            // submitButton.removeAttr('disabled').attr("tabindex", "0");;
            if (!isMobile()) {
                setTimeout(function () {
                    //  submitButton.focus();
                }, 100);
            }
            if (all_correct) {
                //All answers are correct.
            }
        }
        if (!$('.answer-container .dragSpotWrapper .dragSpot').length) {
            DisableLeftArrow();
            DisableRightArrow();
        }

        $('.dropspot').each(function () {
            dropLocation.removeAttr('tabindex');
        });


        app.updateFrames();


        $(".dragspotWrapper .dragspot").unbind('keydown click').bind('keydown click touchstart', handleDragByKey);
        // $(".dragspotWrapper .dragspot .dragHandle").unbind('click touchend').bind('click touchend', handleTap);
        //addTabIndex();
        if ($('.answer-container .dragspot').length) {
            if (!isMobile()) {
                $('.answer-container .dragspot')[0].focus();
            }
        } else {
            setTimeout(function () {
                submitButton.focus();
            }, 100);
        }
    }


    function handleDropByKey(e) {
        if (e.keyCode !== 13 && e.keyCode !== 32) {

        } else {
            tempDragKey.attr("aria-grabbed", 'true');
            $('.dropspot').attr("aria-dropeffect", 'none');
            if ($(this).attr("dropped") != 'true') {
                $(this).attr("dropped", 'true');
                $(this).removeClass('dotted-frame');
                tempDragKey.addClass('correct');
                tempDragKey.position({ of: $(this) });
                tempDragKey.appendTo($(this));
                tempDragKey.css({ 'top': '0px', 'left': '0px', 'position': 'absolute' });
                var correct_answer = $(this).attr('data-answer');
                var dropped_answer = $(this).find('.dragspot').attr('data-answer');
                if (correct_answer == dropped_answer) {
                    $(this).find('.dragspot').addClass('correct-answer');
                }
                else {
                    $(this).find('.dragspot').addClass('incorrect-answer');
                    tempDragKey.removeClass('incorrect-answer');
                    tempDragKey.parent().addClass('dotted-frame');
                    $('.dropspot').removeAttr("tabindex");
                    addTabIndex();
                }
                autoUpdatedDragBoxForTab();
                resetButton.removeClass('disabled');
                resetButton.removeAttr('disabled').attr("tabindex", "0");;
                var all_dropped = true;
                $('.dropspot').each(function () {
                    if ($(this).attr("dropped") != 'true')
                        all_dropped = false;
                });
                if (all_dropped) {
                    submitButton.removeClass('disabled');
                    submitButton.removeAttr('disabled').attr("tabindex", "0");;
                    if (!isMobile())
                        submitButton.focus();
                }
                if (!$('.answer-container .dragSpotWrapper .dragSpot').length) {
                    DisableLeftArrow();
                    DisableRightArrow();
                }
            }
            $('.dropspot').each(function () {
                $(this).removeAttr('tabindex');
            });
            addTabIndex();
            if ($('.answer-container .dragspot').length) {
                if (!isMobile())
                    $('.answer-container .dragspot')[0].focus();
            }
            $('.dropspot .dragspot').unbind('keydown').bind('keydown', handleRemoveDragByKey);
            $('.dropspot .ui-draggable-disabled').unbind('keydown');

            // if ($('.frame').length == 1) {
            //     DisableLeftArrow();
            //     DisableRightArrow();
            // }
        }
    }

    function autoUpdatedDragBoxForTab() {
        lastFrame = $('.answer-container > .frame').last();
        lastFrameDragSpot = $(lastFrame).children().first();
        currentFrame = $(tempkey).parent();
        $(tempkey).remove();
        if (!(($(lastFrame).attr('class')) == ($(currentFrame).attr('class')))) {
            $(currentFrame).append(lastFrameDragSpot);
        }
        if ($(lastFrame).is(':empty')) {
            nCount = 0;
            $(lastFrame).remove();
            aSlidesArray = new Array()
            $(".answer-container .frame").each(function () {
                aSlidesArray.push($(this))
                nCount++;
            });
        }
        if ($(currentFrame).is(':empty')) {
            backSlide();
            $('.rightArrow').addClass('rightArrowDisable');
        }
        lastFrame = $('.answer-container > .frame').last();
        if (($(lastFrame).attr('class')) == ($(currentFrame).attr('class'))) {
            $('.rightArrow').addClass('rightArrowDisable');
        }
        if ($('.answer-container .dragspot').length) {
            if (!isMobile())
                $('.answer-container .dragspot')[0].focus();
        }
        else {
            addTabIndex();
        }
        displayReadMoreIcon();
    }
    /*Anser container Arrow Next Previous */
    function EnableLeftArrow() {
        $(".prev").attr('tabindex', 0);
        $(".prev").removeClass('dnone');
    }
    function DisableLeftArrow() {
        $(".prev").attr('tabindex', -1);
        $(".prev").addClass('dnone');
    }
    function EnableRightArrow() {
        $(".nextPage2").attr('tabindex', 0);
        $(".nextPage2").removeClass('dnone');
    }
    function DisableRightArrow() {
        $(".nextPage2").attr('tabindex', -1);
        $(".nextPage2").addClass('dnone');
    }

    function autoUpdatedDragBox() {
        lastFrame = $('.answer-container > .frame').last();
        lastFrameDragSpot = $(lastFrame).children().first();
        currentFrame = $(tempParent).parent();
        $(tempParent).remove();

        if (!(($(lastFrame).attr('class')) == ($(currentFrame).attr('class')))) {
            $(currentFrame).append(lastFrameDragSpot);
        }
        if ($(lastFrame).is(':empty')) {
            nCount = 0;
            $(lastFrame).remove();
            aSlidesArray = new Array()
            $(".answer-container .frame").each(function () {
                aSlidesArray.push($(this))
                nCount++;
            });
        }
        if ($(currentFrame).is(':empty')) {
            backSlide();
            $('.rightArrow').addClass('rightArrowDisable');
        }
        lastFrame = $('.answer-container > .frame').last();
        if (($(lastFrame).attr('class')) == ($(currentFrame).attr('class'))) {
            $('.rightArrow').addClass('rightArrowDisable');
        }
        var dropspotWidth = $($('.dropspot')[0]).width();
        var dropspotHeight = $($('.dropspot')[0]).height();
        $('.dragspotWrapper').css("width", dropspotWidth + 'px');
        //$('.dragspotWrapper').css("height", dropspotHeight+'px');
        $('.dragspotWrapper').css("height", '62px');
        $('.draglabel .dragspot').css("width", dropspotWidth + 'px');
        $('.draglabel .dragspot').css("height", dropspotHeight + 'px');

        if (config.data.dnd1_activity_type == 'image') {
            $('.dragspot').css({ width: "100px", "padding": '0px' });
        }
        displayReadMoreIcon();
    }
    function fnCheckNextBack() {
        if (config.data.question_list.length > 1 && questionNo < config.data.question_list.length - 1 && questionNo == 0) {
            EnableRightArrow();
            DisableLeftArrow();
        } else if (pageNo === totalPage) {
            EnableLeftArrow();
            DisableRightArrow();
        }
        if (totalPage === 1) {
            DisableRightArrow();
            DisableLeftArrow();
        }
        // $(".page-status").find(".active").removeClass('active');
        // $(".page-status").find("[data-page='" + pageNo + "']").addClass('active');
        // displayReadMoreIcon();
        if ($(".quiz-container").innerHeight() > 80) {
            $(".quiz-container").addClass("break_line");
        } else {
            $(".quiz-container").removeClass("break_line");
        }

    }

    function fnNextPage(e) {
        if (e.type === "click" || e.keyCode === 13 || e.keyCode === 32) {
            pageNo++;
            questionNo = parseInt(config.data.questionPerPage) * pageNo - parseInt(config.data.questionPerPage);
            if (config.data.question_list.length > questionNo) {
                createQues();
                $(".page-status .active").removeClass('active');
                $(".page-status").find("[data-page='" + pageNo + "']").addClass('active');
                app.updateFrames();
            }

            setTimeout(function () {
                fnCheckNextBack();
            }, 100);
        }
    }

    function setPageNo(e) {
        if (e.type === "click" || e.keyCode === 13 || e.keyCode === 32) {
            console.log($(this).data('page'));
            pageNo = parseInt($(this).data('page'));
            questionNo = parseInt(config.data.questionPerPage) * pageNo - parseInt(config.data.questionPerPage);
            if (config.data.question_list.length > questionNo) {
                createQues();
                $(".page-status .active").removeClass('active');
                $(".page-status").find("[data-page='" + pageNo + "']").addClass('active');
                $(".page-status").find('.page-no').removeAttr('aria-current')
                $(".page-status").find("[data-page='" + pageNo + "']").attr('aria-current', 'page');
                app.updateFrames();
            }
            setTimeout(function () {
                fnCheckNextBack();
            }, 100);
        }
    }

    function fnBackPage(e) {
        if (e.type === "click" || e.keyCode === 13 || e.keyCode === 32) {
            pageNo--;
            questionNo = parseInt(config.data.questionPerPage) * pageNo - parseInt(config.data.questionPerPage);
            if (config.data.question_list.length >= questionNo) {
                createQues();
                $(".page-status .active").removeClass('active');
                $(".page-status").find("[data-page='" + pageNo + "']").addClass('active');
                app.updateFrames();
            }

            setTimeout(function () {
                fnCheckNextBack();
            }, 100);
        }
    }
    function fnNext(ev) {
        if (ev.type == "keydown" && ev.keyCode != 13 && ev.keyCode !== 32) {

        } else {
            if (!$("#questionWrapper").hasClass("dnone")) {
                var perPageQues = parseInt(config.data.questionPerPage);
                questionNo++
                if (questionNo < perPageQues * pageNo && questionNo < config.data.question_list.length) {
                    createQues();
                    app.updateFrames();
                    setTimeout(() => {
                        $(".qtitle").focus();
                    }, 500);
                } else {
                    var startQues = pageNo * perPageQues - perPageQues;
                    var endQues = pageNo * perPageQues;
                    var queArr = config.data.question_list.slice(startQues, endQues)
                    var correctArr = correctAnsArr.slice(startQues, endQues);
                    if (correctArr.length <= perPageQues && correctArr.length === queArr.length) {
                        var isFinish = false;
                        var count = 0;
                        correctArr.forEach(ele => {
                            if (ele) {
                                count += 1;
                            }
                        })
                        if (correctArr.length == count) {
                            isFinish = true;
                            $(".dragspotWrapper .dragspot").unbind('keydown click touchstart', handleDragByKey);
                            statusContainer.find(".audio-btn").attr('data-src', 'audio/' + config.data.play_again_audio);
                            statusContainer.find(".status-back").addClass("again").removeClass('back').removeClass('next');
                            statusContainer.find(".status-text").text("play again");
                            $(".again").unbind().bind("click keydown", playAgain);
                            showAllAns(startQues, endQues);
                        }
                    }
                }
            }
        }
    }
    function fnBack(ev) {
        if (ev.type == "keydown" && ev.keyCode != 13 && ev.keyCode !== 32) {
        } else {
            backSlide();
            addTabIndex()
        }
    }
    function backSlide() {
        if (questionNo > 0) {
            if (questionNo % parseInt(config.data.questionPerPage) === 0 && questionNo !== 0) {
                questionNo--;
                pageNo--
            } else {
                questionNo--;
            }
        } else {
            DisableLeftArrow();
        }
        createQues();
        app.updateFrames();
        setTimeout(function () {
            fnCheckNextBack();
        }, 100);
    }
    function detectDevice() {
        var screenWidth = $(window).width();
    }
})(Widget = Widget || {});
var Widget;
$(document).ready(function () {
});
$(window).resize(function () {
    Widget.setParameters();
    Widget.updateFrames();
    });
var parentBottomOffset;
var isMobile;
